#include "TH1.h"
#include "TMath.h"
#include "TF1.h"
#include "TLegend.h"
#include "TGraphErrors.h"
#include "TCanvas.h"
#include <stdio.h>
#include <stdlib.h>


Double_t fitf(Double_t *x, Double_t *par){
  Double_t fitVAL = 
    (par[0]*par[0] - par[1] - par[2])/pow(1+par[3]*x[0]*x[0],par[6]) +
    par[1]/pow(1+par[4]*x[0]*x[0],par[7]) +
    par[2]/pow(1+par[5]*x[0]*x[0],par[8]);
  return fitVAL;
}

string sInt(int number)
  {
    stringstream ss;//create a stringstream
    ss << number;//add number to the stream
    return ss.str();//return a string with the contents of the stream
  }
  vector<double>PP[9];
  
  // reading 9 fitting parameters of FormFactor, of old version, used in G4RayleighAngularGenerator class
	void ReadFit9Parameters()
	{
		std::ostringstream ost;
		for(int i = 0; i<9;i++)
		{
			PP[i].reserve(101);
			ost << "./PP" << i <<".dat";
			std::ifstream fin(ost.str().c_str());
			double x;
			PP[i].push_back(0);
			for(int z = 1; z<=100;z++)
			{
				fin >> x;
				PP[i].push_back(x);
				// cout<<"PP"<<i<<" "<<z<<" "<<PP[i][z]<<endl;;
			}	
			fin.close();
			ost.str("");
			ost.clear();

		}


	}
void plotAverageRatio(vector<double>& X, vector<double>& averageR1, vector<double>& averageR2, vector<double>& averageR5)
{
	gROOT->Reset();
	gStyle->SetOptStat(0);
	gStyle->SetOptFit();
	
	
	// calculate the factor of fit precision improved by new fit method
	double sum;
	for(int i = 0; i<100;i++)
	{
		sum+=abs((averageR2[i]/averageR1[i]));
		
	}
	
	printf("factor on average of fit = %.9e\n", sum/100);
	
	
	
	TCanvas *mycanvas2 = new TCanvas("mycanvas2","average ratio",800,50, 400, 400);
	mycanvas2->cd();
	// gPad->SetLogy();
	// gPad->SetLogx();
	mycanvas2->SetGrid();
	gPad->SetGrid();
	gPad->SetBottomMargin(0.15);
	gPad->SetLeftMargin(0.15);
		
	TGraph *average1 = new TGraph(X.size(),X.data(),averageR1.data()); 
	TGraph *average2 = new TGraph(X.size(),X.data(),averageR2.data()); 
	TGraph *average5 = new TGraph(X.size(),X.data(),averageR5.data()); 
	
	auto mg = new TMultiGraph();
	
	
	
	average2->SetMarkerStyle(21);  // modified fit
	average2->SetMarkerSize(0.8);
	average2->SetMarkerColor(kBlue);
	//average2->SetLineWidth(2);
	average2->SetLineColor(kBlue);
	mg->Add(average2);
	
	
	
	
	average1->SetMarkerStyle(24);  // modified fit
	average1->SetMarkerSize(1.2);
	average1->SetMarkerColor(kRed);
	//average1->SetLineWidth(2);
	average1->SetLineColor(kRed);
	mg->Add(average1);
	
	average5->SetMarkerStyle(24);  // modified fit
	average5->SetMarkerSize(1.5);
	average5->SetMarkerColor(kGreen);
	//average5->SetLineWidth(2);
	average5->SetLineColor(kGreen);
	// mg->Add(average5);
	
	mg->Draw("AP");
	TString title2 = "Average absolute difference of fits according to Z";
	// mg->SetTitle(title2);		
	mg->GetXaxis()->SetTitle("Atomic number (Z)");
	mg->GetYaxis()->SetTitle("Absolute average difference (%)");
	
	// mg->GetXaxis()->SetTitleSize(0.06);
	// mg->GetYaxis()->SetTitleSize(0.06);
		
	// mg->GetXaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelSize(0.05);
	
	mg->GetXaxis()->CenterTitle();
	mg->GetYaxis()->CenterTitle();
	
	mg->GetXaxis()->SetTitleOffset(1.5);
	mg->GetYaxis()->SetTitleOffset(1.5);
	mg->GetXaxis()->SetLimits(0, 101);
		
	TGaxis *axisX = new TGaxis(0,gPad->GetUymax(),
	101, gPad->GetUymax(),
	mg->GetXaxis()->GetXmin(),
	mg->GetXaxis()->GetXmax(), 510,"U-");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisX->Draw("");
	
	
	TGaxis *axisY = new TGaxis(101,gPad->GetUymin(),
	101, gPad->GetUymax(),
	mg->GetYaxis()->GetXmin(),
	mg->GetYaxis()->GetXmax(), 510,"U+");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisY->Draw();
		
	
	
	TLegend* leg = new TLegend(0.55,0.75,0.9,0.9);
	// leg->SetTextAlign(12);
	// leg->SetFillColor(0);
	leg->SetFillStyle(0);		
	leg->SetTextSize(0.04);
	
	TString rname1 = "New fit";
	TString rname2 = "Geant4 fit using EPICS2017";
	TString rname5 = "Geant4 fit using EPICS2014";
	
	
	leg->AddEntry(average1,rname1);
	leg->AddEntry(average2,rname2);
	leg->AddEntry(average5,rname5);
	// leg->AddEntry(graph24,rname24);
	
	//leg->DrawClone("Same");
	// leg->Draw();
	
	
	mycanvas2->Print("plots/AverageRatioOfFits_2014_2017.png");
	delete mycanvas2;
	mycanvas2 = NULL;
	
	FILE* file = fopen("plots/average", "w");
	for(int i = 0; i<X.size();i++)
	{
		fprintf(file, "%.1e %.9e %.9e \n",X[i], averageR1[i], averageR2[i]);
	}
	
	fclose(file);
	
}
// void fit_formFactor_2017_updated(int t)
// void fit_formFactor_2017()
// {
	// gSystem->Exec("mkdir -p plots/Fit_FF_compare_2017");
	// gSystem->Exec("mkdir -p plots/Fit_FF_finalCompare_2017VS2014");
	
	// gROOT->Reset();
	// gStyle->SetOptStat(0);
	// gStyle->SetOptFit();
	
	// ReadFit9Parameters();
   
	// // return;

	// Double_t x, y;   
	// Double_t x1, x2, y1, y2; 
	// Double_t ZZ0[101]={0};   
	// Double_t PP0[101]={0};   
	// Double_t PP1[101]={0};   
	// Double_t PP2[101]={0};   
	// Double_t PP3[101]={0};   
	// Double_t PP4[101]={0};   
	// Double_t PP5[101]={0};   
	// Double_t PP6[101]={0};   
	// Double_t PP7[101]={0};   
	// Double_t PP8[101]={0};
	// vector<double> PPP[9]; // 9 vectors, each vector has 101 elements
	// vector<double> XXX(100); 
	// vector<double> averageRVec1(100);
	// vector<double> averageRVec2(100);
	// vector<double> averageRVec5(100);
	// for(int i=0; i<100; i++)
	// {
		// XXX[i] = i+1; // XXX contains Z atomic number
		// averageRVec1[i] = 0;
		// averageRVec2[i] = 0;
		// averageRVec5[i] = 0;
	// }
	
	// for(int i = 0; i<9; ++i)
	// {
		
		// PPP[i].reserve(101);
		// // PPP[i].push_back(0);
		// PPP[i][0] = 0;
		// // cout<<"ggggggggggg"<<PPP[i].capacity()<<" "<<PPP[i][0]<<endl;
	// }
   // // return;
	// char line[200];  

	// Double_t xxx[2000]={0};   
	// Double_t yyy[2000]={0};   
	// Double_t erx[2000]={0};   
	// Double_t ery[2000]={0}; 
	// Int_t N=0, nn=0; 
	// Int_t k = 0;
	// // Int_t ZZ = t;
	

	// // for(Int_t i=ZZ; i<=ZZ; i++) 
	// for(Int_t i=1; i<=100; i++) 
	// {
		// vector<double> X;
		// vector<double> XX;
		// vector<double> Y_tab;
		// vector<double> Y_fit1; // real fit
		// vector<double> Y_fit2; // modified fit after real fit
		// vector<double> Y_fit3; // Geant4 fit
		// vector<double> Y_fit4; // final fit (modified fit + geant4 fit)
		
		// vector<double> R_fit1;
		// vector<double> R_fit2;
		// vector<double> R_fit3;
		// vector<double> R_fit4;
		
		// vector<double> R_fit33;  // to save the points without momentum transfer = 0
		// vector<double> R_fit44;
		// vector<double> R_fit55;
		// k = i;
    // // for(Int_t i=82; i<83; i++) {

		// Int_t Z=i;
		// cout <<  " " << endl;
		// cout <<  "Next Element " << endl;
		// cout <<  "Element " << Z  << endl;
		// TString s = sInt(Z);
		// // TString datafile="data/re-ff-" + s + ".dat";
		// TString datafile="./epics2017/formFactor/re-ff-" + s + ".dat";
		// // TString datafile="epics2014/formFactor/re-ff-" + s + ".dat";
		// // TString datafile="epics2014/formFactor/g4/re-ff-" + s + ".dat";
		// // string ffdata = datafile; 
    
    // //OUT
    // //TString ffname = "out_" + s + ".txt";       //output file
    // //string fname = ffname;    
    // //ofstream fout(fname.c_str(), ios::out);      
  
    // //IN
    // ifstream  data_file(datafile, ios::in );
    // if(data_file.fail()){
      // cout << "Error opening data file"  << endl;
    // }else cout << "data file " << datafile << " is opened" << endl;

    // Int_t pp=0;  // how much points to substract
    // data_file.getline(line, 50); //cout << line << endl;
    // data_file >> nn ;
    // x1 = 1; y1 = 1;
    // cout << "number of points: "<<nn << endl;
    // Double_t P = 8;
    // Double_t P0,P1,P2;
    // Double_t lim = Z*Z/pow(2,P);  //* when Z<16, lim < 1
    // Double_t limy = 1.e-6;
    // // Double_t limy = Z*Z*1.e-15;
    // Int_t n1 = 0;
    // for (N = 0; N < nn; N++) 
	// {
		// if(!data_file) break;
		// data_file >> x >> y;
		
		// x*=1e14;  // to make the unit of momentum transfer cm-1
		// y2 = y*y;
		// X.push_back(x);
		// Y_tab.push_back(y2);
		// // if(x1 == 1)
		// // {
			// // cout<<N<<" zhuxin----"<<endl;
			// // // x1=x;
		// // }
	  
      // if(x1 == 1 && y2 < lim){cout<<"--stop--"<<endl; x1=x; y1=y2;}   
      // x2 = x;
      // xxx[N] = x;   
      // yyy[N] = y2;   
      // erx[N] = 0;   
      // ery[N] = y2*0.1*(1. + log10((Z*Z)/y2));
	  
	  // // exceptions because erro=0.05 leads to better fit results
	  // if( Z==29 || Z==30 ||Z==90 )
	  // {
		  // ery[N] = y2*0.05;
	  // }
      
	  // // printf("%d %.9e %.9e %.9e\n",N, x, y, yyy[N]);
	  
      // // ery[N] = y2*0.05;
      // if(0 == n1 && y2 < Z*Z*limy) {  n1 = N; cout<<"--test--"<<n1<<" "<<x<<endl;}
    // }
	// data_file.close();
	// Int_t Bin = n1;
	
	// //****************Read EPICS2014*******************begin
	// Int_t num = 0;  
	// Int_t ncols;
	// double q, ff;
	// Int_t loop = 0;
	// char str[64] = "";
	
	// char path2Format[128] = "./epics2014/formFactor/re-ff-%d.dat"; //prefix of the name of original data file
	// char path2[128];	
	// sprintf(path2,path2Format, Z);
	
		
	// FILE * fp = fopen(path2,"r");

	// while(1)  
	// {	
		// loop++;
		// // if loop = 1 we read the first header line
		// fgets (str, 64, fp);
		// // cout<<str<<endl;
		// if(loop ==2)
		// {
			// // now loop = 2, we read the second header line, namely the number of points
			// num = stoi(str);  
			// cout<<"number of form factor points:"<<num<<endl;
			// break;
		// }		
		
	// }
	
	// vector<double> X_g4;
	// vector<double> XX_g4; // to remove the first point
	// vector<double> Y_tab_g4;
	// vector<double> Y_fit_g4;
	// vector<double> R_fit_g4;
	// for(Int_t i = 0;i<num;++i)
	// {
		
		// // read one line energy cross section
		// ncols = fscanf(fp,"%lf %lf",&q,&ff); 
		// if(q>xxx[Bin-1]) 
		// {
			// // printf("-----------%.9e %.9e\n", q, ff);
			// break;
		// }
		// // printf("**********%.9e %.9e\n", q, ff);
		
		// X_g4.push_back(q);
		// Y_tab_g4.push_back(ff*ff);
	// }
	// fclose(fp);
	
	// //****************Read EPICS2014*******************end
	
	
	
    
	
	// // for(int i=0; i<nn;++i)
	// // for(int i=0; i<Bin;++i)
	// // {
		// // cout<<i<<" "<<xxx[i]<<" "<<yyy[i]<<endl;
	// // }
	
    // // Bin = n1;
    // cout <<  "Bin = " << Bin << ", xxx[Bin-1] = "<<xxx[Bin-1]<<endl;
    // TCanvas *c = new TCanvas("c","GraphFit",800,50, 1000, 800);  
    // // TCanvas *c = new TCanvas("c","GraphFit",.0, xxx[Bin], 1000, 800);  
	// c->cd();
    // P = 4 - 0.0157*Z;
    // Double_t B=(pow(2.0,1.0/P)-1)/(x1*x1);
	
    // // P2 = P;
	
    // // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    // // if (Z>2 && Z<=64){
      // // P0 = 0.5*log(yyy[nn-3]/yyy[nn-1])/log(xxx[nn-1]/xxx[nn-3]);
    // // }
	// // if (Z>2 && Z<=64){
	// // if (Z>2 && Z<=64){
	// // // if (Z>=1 && Z<=64){
      // // // P0 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  // // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    
	 // // P1 = P0;
    
	// // }
	
	// // if (Z<=10){
      // // //   P0 
      // // P2 = P;
      // // P1 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // // }else if (Z>10 && Z<=64){
      // // P2 = P;
      // // P1 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
      // // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // // }else{
      // // P2 = P;
      // // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // P1 = P0;
    // // }
	
	// if (Z<=10)
	// {
        // // P0 
      // P2 = P;
	  // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
	  // P1 = P0;
	  // if(Z ==3)
	  // {
		  // // cout<<"333333333333"<<endl;
		  // P1 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
		  // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
	  // }
    // }
	// else if (Z>10 && Z<=64)
	// {
      // P2 = P;
	  // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // P0 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
	  // P1 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  // cout<<"zhuxin "<<yyy[n1-1]/yyy[n1-3]<<endl;
	  // // P0 = P1;
     
    // }
	// else
	// {
      // P2 = P;
      // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // P1 = P0;
	  // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    // }
    // cout <<  "B= " << B << "  P = " << P << "  P0 = " << P0 
	 // << "  P1 = " << P1 << "  P2 = " << P2<< endl;
    // if(B < 0.0) { B = 0.0; }
    // TF1 *fitFcn = new TF1("fitFcn",fitf,xxx[0],xxx[Bin],9);
   
  
  
	// if(Z == 2 || Z == 4 || Z == 5 || Z == 6 || Z == 13 || Z == 20 || Z == 22 || Z == 46  || Z == 48  || Z == 54
	// || Z == 55 || Z == 55 || Z == 58 || Z == 66 || Z == 68 || Z == 69 || Z == 70 || Z == 71 || Z == 72 
	// || Z == 85 || Z == 90 || Z == 92  || Z == 94 || Z == 99)	
	 // {
		 // fitFcn->SetParameters(Z,PP[1][Z],PP[2][Z],PP[3][Z],PP[5][Z],PP[6][Z],PP[7][Z], PP[8][Z]);
	 // }	
	// else
	// {
		// fitFcn->SetParameters(Z,Z*Z/6,Z*Z/6,B,B,B,P2,P1,P0); 
	// }	 
		
	
    // fitFcn->FixParameter(0,Z); 
    // fitFcn->SetParLimits(1,Z*Z/10,Z*Z/2); 
    // fitFcn->SetParLimits(3,B/1000,B*1000); 
    // fitFcn->SetParLimits(4,B/1000,B*1000); 
    // fitFcn->SetParLimits(6,P2/2,P2*2); 
    // fitFcn->SetParLimits(7,P1/2,P1*2); 
    // if(Z<=2){
      // fitFcn->FixParameter(2,0); 
      // fitFcn->FixParameter(5,B); 
      // fitFcn->FixParameter(8,P0);  
    // }
	// else {
      // fitFcn->SetParLimits(2,0,Z*Z/2); 
      // fitFcn->SetParLimits(5,B/1000,B*1000); 
      // fitFcn->SetParLimits(8,P0/2,P0*2); 
    // }

	// gPad->SetLogy();
	// gPad->SetLogx();

    // // TGraphErrors *gr = new TGraphErrors(nn, xxx, yyy, erx, ery); 
    // TGraphErrors *gr = new TGraphErrors(Bin, xxx, yyy, erx, ery); 
    // gr->SetTitle("FF Fit");
    // gr->Draw("ALP*");
    // gr->Fit(fitFcn);
	// // return;
	
	
    // Double_t p1 =  fitFcn->GetParameter(1);
    // if(p1 < 1.e-8) { p1 = 0;}
    // Double_t p2 =  fitFcn->GetParameter(2);
    // if(p2 < 1.e-8) { p2 = 0;}
    // Double_t p0 =  Z*Z - p1 - p2;
    // Double_t p3 =  fitFcn->GetParameter(3);
    // Double_t p4 =  fitFcn->GetParameter(4);
    // Double_t p5 =  fitFcn->GetParameter(5);
    // Double_t p6 =  fitFcn->GetParameter(6);
    // Double_t p7 =  fitFcn->GetParameter(7);
    // Double_t p8 =  fitFcn->GetParameter(8);

    // if(p1 < 1.e-5) { p1 = 0;}
    // if(p2 < 1.e-5) { p2 = 0;}

    // PP0[Z]=p0;
    // PP1[Z]=p1; 
    // PP2[Z]=p2; 
    // PP3[Z]=p3;
    // PP4[Z]=p4; 
    // PP5[Z]=p5; 
    // PP6[Z]=p6; 
    // PP7[Z]=p7;
    // PP8[Z]=p8;


    // c->Update();
    // fitFcn->SetParameters(Z,PP1[Z],PP2[Z],PP3[Z],PP4[Z],PP5[Z],PP6[Z],PP7[Z],PP8[Z]); 
    // fitFcn->FixParameter(0,Z); 
    // fitFcn->SetParLimits(1,PP1[Z]/2,Z*Z/2); 
    // fitFcn->SetParLimits(2,PP2[Z]/2,Z*Z/2); 
    // fitFcn->SetParLimits(3,PP3[Z]/1000,PP3[Z]*1000); 
    // fitFcn->SetParLimits(4,PP4[Z]/1000,PP4[Z]*1000); 
    // fitFcn->SetParLimits(5,PP5[Z]/1000,PP5[Z]*1000); 
    // fitFcn->SetParLimits(6,PP6[Z]/2,PP6[Z]*2); 
    // fitFcn->SetParLimits(7,PP7[Z]/2,PP7[Z]*2); 
    // fitFcn->SetParLimits(8,PP8[Z]/2,PP8[Z]*2); 
	
    // if(Z<=2){
      // fitFcn->FixParameter(2,0); 
      // fitFcn->FixParameter(5,p5); 
      // fitFcn->FixParameter(8,p8);  
    // }
    // if(p1 < 1.e-5) { 
      // fitFcn->FixParameter(1,0); 
      // fitFcn->FixParameter(4,p4); 
      // fitFcn->FixParameter(7,p7);  
    // }
    // if(p2 < 1.e-5) { 
      // fitFcn->FixParameter(2,0); 
      // fitFcn->FixParameter(5,p5); 
      // fitFcn->FixParameter(8,p8);  
    // }
    // gr->Fit(fitFcn);
 

	// p1 =  fitFcn->GetParameter(1);
	// if(p1 < 1.e-5) { p1 = 0;}
	// p2 =  fitFcn->GetParameter(2);
	// if(p2 < 1.e-5) { p2 = 0;}
	// p0 =  Z*Z - p1 - p2;
	// p3 =  fitFcn->GetParameter(3);
	// p4 =  fitFcn->GetParameter(4);
	// p5 =  fitFcn->GetParameter(5);
	// p6 =  fitFcn->GetParameter(6);
	// p7 =  fitFcn->GetParameter(7);
	// p8 =  fitFcn->GetParameter(8);
	
	

	// PP0[Z]=p0;
	// PP1[Z]=p1; 
	// PP2[Z]=p2; 
	// PP3[Z]=p3;
	// PP4[Z]=p4; 
	// PP5[Z]=p5; 
	// PP6[Z]=p6; 
	// PP7[Z]=p7;
	// PP8[Z]=p8;
	
	// // to make writing easier (begin)
	// double ppp[9];
	// ppp[0] = p0;
	// ppp[1] = p1;
	// ppp[2] = p2;
	// ppp[3] = p3;
	// ppp[4] = p4;
	// ppp[5] = p5;
	// ppp[6] = p6;
	// ppp[7] = p7;
	// ppp[8] = p8;
	
	
	// for(int i = 0; i<9; ++i)
	// {
		
		// //replace new fitting paramters with previous fitting parameters for the following elements,
		// // because the new fitting can not perform better than old		
		// PPP[i][Z] = ppp[i];
		// // cout<<"ggggggggggg "<<PPP[i].capacity()<<" "<<PPP[i][0]<<endl;
		
		// // if( Z==3 || Z==13 || Z==19 || Z==20 || Z==21 || Z==22 || Z==46 || Z==52 || Z==56 || Z==58 || Z==63
			// // || Z==66 || Z==68 || Z==74 || Z==99)
			
		// if( Z==3 || Z==19 || Z==21 || Z==36 ||Z==44 || Z==45 ||Z==52 || Z==56 || Z==63 || Z==74)
		// {
			// PPP[i][Z] = PP[i][Z];
		// }
	// }	
		
    // // to make writing easier (end)
		// gr->SetLineColor(kBlue);
		// // gr->Draw("ALP* SAME");
		
		// TString name="plots/Fit_FF_2017/Ahisto_" + s + ".gif";
		// c->Print(name);
		// delete c;
		// c = NULL;
		
		// TCanvas *mycanvas = new TCanvas("mycanvas",s,800,50, 1000, 800);
		// mycanvas->Divide(1,2);
		// mycanvas->cd(1);
		// gPad->SetLogy();
		// gPad->SetLogx();
		// cout<<"--real fit: "<<fitFcn->GetParameter(0)<<" "<<fitFcn->GetParameter(1)<<" "<<fitFcn->GetParameter(2)<<endl;
		// cout<<"--modified fit: "<<p0<<" "<<p1<<" "<<p2<<endl<<endl;
		// cout<<"Previous fitting parameters: PP0 = "<<PP[0][Z]<<" PP1 = "<<PP[1][Z]<<" PP2 = "<<PP[2][Z]<<" PP3 = "<<PP[3][Z]<<
		// " PP4 = "<<PP[4][Z]<<" PP5 = "<<PP[5][Z]<<" PP6 = "<<PP[6][Z]<<" PP7 = "<<PP[7][Z]<<" PP8 = "<<PP[8][Z]<<endl;
		// //*******************
		
		
		// double totalR1 = 0;
		// double totalR2 = 0;
		// // for(int i = 0; i< nn; i++)
		// for(int i = 0; i< Bin; i++)
		// {
			
			// double y1 = fitFcn->Eval(X[i]); //real fit
			// // double PPP0 = fitFcn->GetParameter(0);
			// // double y0 = (PPP0*PPP0 - PP1[Z] - PP2[Z])/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// // PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// // PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
				
			// // modified fit (old verison, but false)
			// // double y2 = (PP0[Z]*PP0[Z] - PP1[Z] - PP2[Z])/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// // PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// // PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
						
			// // modified fit based on real fit			
			// double y2 = PP0[Z]/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
						
			// // double y3 = (PP[0][Z]*PP[0][Z] - PP[1][Z] - PP[2][Z])/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						// // PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						// // PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
			
			// // geant4 fit, using EPICS2017 data
			// double y3 = PP[0][Z]/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						// PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						// PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
						
			// // final fit for 2017 PPP[i][Z], which is the combination of 5% errors and geant4 fit(2014)
			// double y4 = PPP[0][Z]/pow(1+PPP[3][Z]*X[i]*X[i],PPP[6][Z]) +
						// PPP[1][Z]/pow(1+PPP[4][Z]*X[i]*X[i],PPP[7][Z]) +
						// PPP[2][Z]/pow(1+PPP[5][Z]*X[i]*X[i],PPP[8][Z]);			
			
			// double r1 = (y1-Y_tab[i])/Y_tab[i]*100;
			// double r2 = (y2-Y_tab[i])/Y_tab[i]*100;
			// double r3 = (y3-Y_tab[i])/Y_tab[i]*100;
			// double r4 = (y4-Y_tab[i])/Y_tab[i]*100;
			
			
			
			
			// totalR1 +=abs(r4);
			// totalR2 +=abs(r3);
			// Y_fit1.push_back(y1);		
			// Y_fit2.push_back(y2);
			// Y_fit3.push_back(y3);			
			// Y_fit4.push_back(y4);
			
			
			// R_fit1.push_back(r1);
			// R_fit2.push_back(r2);
			// R_fit3.push_back(r3);
			// R_fit4.push_back(r4);
			// if(i!=0)  // to remove the first point FF = 0
			// {
				// R_fit33.push_back(r3);
				// R_fit44.push_back(r4);
				// XX.push_back(X[i]);
				// // printf("******%d %.9e %.9e\n", i, X[i], r4);
			// }
			
			// // printf("____%d %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y2);
			// // printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y0, y2);
			// // printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y2, y3);
			// // printf("____%d %.9e %.9e\n", i, X[i], r4);
		// }
		// double totalR5 = 0;
		// // geant4 fit using EPICS2014
		// for(int i = 0; i<X_g4.size(); i++)
		// {
			// // geant4 fit, using EPICS2017 data
			// double y5 = PP[0][Z]/pow(1+PP[3][Z]*X_g4[i]*X_g4[i],PP[6][Z]) +
						// PP[1][Z]/pow(1+PP[4][Z]*X_g4[i]*X_g4[i],PP[7][Z]) +
						// PP[2][Z]/pow(1+PP[5][Z]*X_g4[i]*X_g4[i],PP[8][Z]);
						
			// double r5 = (y5-Y_tab_g4[i])/Y_tab_g4[i]*100;
			// totalR5 +=abs(r5);
			// if(i ==0) continue;
			// // starting from i = 1, in order not to show the first point, the size of XX_g4 = XX_g4.size()
			// XX_g4.push_back(X_g4[i]);
			// Y_fit_g4.push_back(y5);
			// R_fit_g4.push_back(r5);
			// printf("********%.9e %.9e %.9e %.9e\n", X_g4[i], Y_tab_g4[i], y5, r5);
		// }
		
		
		// double averageR1 = totalR1/Bin;   //new fit using EPICS2017, note that average contains the first point
		// double averageR2 = totalR2/Bin;   // old fit using EPICS2017
		// double averageR5 = totalR5/X_g4.size();   // odl fit using EPICS2014
		// printf("***%.9e %.9e\n", totalR1, averageR1);
		// printf("***%.9e %.9e\n", totalR2, averageR2);
		// printf("***%.9e %.9e\n", totalR5, averageR5);
		// averageRVec1[Z-1] = averageR1;
		// averageRVec2[Z-1] = averageR2;
		// averageRVec5[Z-1] = averageR5;
		
		// TGraph *graph0 = new TGraph(Bin,X.data(),Y_tab.data());
		// TGraph *graph1 = new TGraph(Bin,X.data(),Y_fit1.data());
		// TGraph *graph2 = new TGraph(Bin,X.data(),Y_fit2.data());
		// TGraph *graph3 = new TGraph(Bin,X.data(),Y_fit3.data());
		// TGraph *graph4 = new TGraph(XX_g4.size(),XX_g4.data(),Y_fit_g4.data());
		
		// auto mg = new TMultiGraph();
		
		
		// graph2->SetMarkerStyle(24);  // modified fit
		// graph2->SetMarkerSize(1.3);
		// graph2->SetMarkerColor(kRed);
		// //graph2->SetLineWidth(2);
		// graph2->SetLineColor(kRed);	
		// mg->Add(graph2);
		
		// graph1->SetMarkerStyle(24);  // real fit
		// graph1->SetMarkerSize(1.0);
		// graph1->SetMarkerColor(kBlue);
		// //graph1->SetLineWidth(2);
		// graph1->SetLineColor(kBlue);	
		// mg->Add(graph1);	
		
		
		// graph3->SetMarkerStyle(20);  // geant4 fit
		// graph3->SetMarkerSize(0.7);
		// graph3->SetMarkerColor(kYellow);
		// //graph2->SetLineWidth(2);
		// graph3->SetLineColor(kYellow);	
		// mg->Add(graph3);
		
		
		// graph4->SetMarkerStyle(20);  // geant4 fit
		// graph4->SetMarkerSize(0.7);
		// graph4->SetMarkerColor(kMagenta);
		// //graph2->SetLineWidth(2);
		// graph4->SetLineColor(kMagenta);	
		// mg->Add(graph4);
		
		
		// graph0->SetMarkerStyle(20);  // tabulated data
		// graph0->SetMarkerSize(0.4);
		// graph0->SetMarkerColor(kTeal+4);
		// //graph1->SetLineWidth(2);
		// graph0->SetLineColor(kTeal+4);	
		// mg->Add(graph0);
		
		// mg->Draw("AP");
		// TString title = "EPDL2017: Fif of FF{2} using 2014 parameters and new fit() fitted FF(square) VS tabulated FF(square) for element " + s;
		// mg->SetTitle(title);		
		// mg->GetXaxis()->SetTitle("Momentum transfer");
		// mg->GetYaxis()->SetTitle("Square of FF");
		
		
		// TLegend* leg = new TLegend(0.15,0.7,0.35,0.9);
		// // leg->SetTextAlign(12);
		// // leg->SetFillColor(0);
		// leg->SetFillStyle(0);		
		// leg->SetTextSize(0.04);
		
		// TString rname10 = "Tabulated data";
		// TString rname11 = "Real fit";
		// TString rname12 = "Modified fit";
		// TString rname13 = "Geant4 fit using EPICS2017";
		// TString rname14 = "New fit";
		// TString rname15 = "Geant4 fit using EPICS2014";
		
		// leg->AddEntry(graph0,rname10);
		// leg->AddEntry(graph1,rname11);
		
		
		// leg->AddEntry(graph2,rname12);
		// leg->AddEntry(graph3,rname13);
		// leg->AddEntry(graph4,rname15);
		// // leg->AddEntry(graph24,rname24);
		
		// //leg->DrawClone("Same");
		// leg->Draw();
		
		
		
		
		
		// //*************************************************
		// mycanvas->cd(2);
		// // gPad->SetLogy();
		// gPad->SetLogx();
		
		// TGraph *ratio1 = new TGraph(Bin,X.data(),R_fit1.data());
		// TGraph *ratio2 = new TGraph(Bin,X.data(),R_fit2.data());
		// TGraph *ratio3 = new TGraph(Bin,X.data(),R_fit3.data());
		// TGraph *ratio4 = new TGraph(XX_g4.size(),XX_g4.data(),R_fit_g4.data());
		// auto mg1 = new TMultiGraph();
		
		
		
		
		
		// ratio2->SetMarkerStyle(24); 
		// ratio2->SetMarkerSize(1.3);
		// ratio2->SetMarkerColor(kRed);
		// //ratio2->SetLineWidth(2);
		// ratio2->SetLineColor(kRed);	
		// mg1->Add(ratio2);
		
		// ratio1->SetMarkerStyle(24);  
		// ratio1->SetMarkerSize(1.);
		// ratio1->SetMarkerColor(kBlue);
		// //ratio1->SetLineWidth(2);
		// ratio1->SetLineColor(kBlue);	
		// mg1->Add(ratio1);
		
		// ratio3->SetMarkerStyle(20);  
		// ratio3->SetMarkerSize(0.7);
		// ratio3->SetMarkerColor(kYellow);
		// //ratio3->SetLineWidth(2);
		// ratio3->SetLineColor(kYellow);	
		// mg1->Add(ratio3);
		
		// ratio4->SetMarkerStyle(20);  
		// ratio4->SetMarkerSize(0.7);
		// ratio4->SetMarkerColor(kMagenta);
		// //ratio4->SetLineWidth(2);
		// ratio4->SetLineColor(kMagenta);	
		// mg1->Add(ratio4);
		
		// mg1->Draw("AP");
		// TString title1 = "EPDL2017: Relative difference of real fitted FF(square) + modified FF(square) for element " + s;
		// mg1->SetTitle(title);		
		// mg1->GetXaxis()->SetTitle("Momentum transfer");
		// mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		// TLegend* leg1 = new TLegend(0.15,0.7,0.35,0.9);
		// // leg1->SetTextAlign(12);
		// // leg1->SetFillColor(0);
		// leg1->SetFillStyle(0);		
		// leg1->SetTextSize(0.04);
		
		// // TString rname11 = "Real fit";
		// // TString rname12 = "Modified fit";
		
		// leg1->AddEntry(ratio1,rname11);
		// // leg1->AddEntry(graph14,rname14);
		
		// leg1->AddEntry(ratio2,rname12);
		// leg1->AddEntry(ratio3,rname13);
		// leg1->AddEntry(ratio4,rname15);
		
		// //leg1->DrawClone("Same");
		// leg1->Draw();
		
		
		// TString name1="plots/Fit_FF_compare_2017/Ahisto_" + s + ".gif";
		// mycanvas->Print(name1);
		// delete mycanvas;
		// mycanvas = NULL;
		
		// //******************************
		// TCanvas *mycanvas1 = new TCanvas("mycanvas1",s,800,50, 1000, 800);
		// mycanvas1->Divide(1,2);
		// mycanvas1->cd(1);
		// gPad->SetLogy();
		// gPad->SetLogx();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.15);
		
		// TGraph *gg0 = new TGraph(Bin,X.data(),Y_tab.data()); // tabulated data
		// TGraph *gg3 = new TGraph(Bin,X.data(),Y_fit3.data()); // geant4 fit using EPICS2017
		// TGraph *gg4 = new TGraph(Bin,X.data(),Y_fit4.data());  // final fit
		// TGraph *gg5 = new TGraph(XX_g4.size(),XX_g4.data(),Y_fit_g4.data());  // final fit
		
		// auto mg2 = new TMultiGraph();
		
		
		// gg3->SetMarkerStyle(24);  // geant4 data
		// gg3->SetMarkerSize(1.0);
		// gg3->SetMarkerColor(kGreen);
		// //gg3->SetLineWidth(2);
		// gg3->SetLineColor(kGreen);	
		// mg2->Add(gg3);
		
		// gg4->SetMarkerStyle(24);  // final fit
		// gg4->SetMarkerSize(1.5);
		// gg4->SetMarkerColor(kRed);
		// //gg4->SetLineWidth(2);
		// gg4->SetLineColor(kRed);	
		// mg2->Add(gg4);
		
		
		// gg0->SetMarkerStyle(20);  // tabulated data
		// gg0->SetMarkerSize(0.4);
		// gg0->SetMarkerColor(kTeal+4);
		// //gg1->SetLineWidth(2);
		// gg0->SetLineColor(kTeal+4);	
		// mg2->Add(gg0);
		
		// gg5->SetMarkerStyle(24);  // final fit
		// gg5->SetMarkerSize(1.5);
		// gg5->SetMarkerColor(kBlue);
		// //gg5->SetLineWidth(2);
		// gg5->SetLineColor(kBlue);	
		// mg2->Add(gg5);
		
		
		// mg2->Draw("APL");
		// TString title2 = "EPDL2017: Fif of FF^{2} using 2014 parameters and new fit parameters (2017) for element " + s;
		// mg2->SetTitle(title2);		
		// mg2->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		// mg2->GetYaxis()->SetTitle("FF^{2}");
		
		// mg2->GetXaxis()->SetTitleSize(0.06);
		// mg2->GetYaxis()->SetTitleSize(0.06);
			
		// mg2->GetXaxis()->SetLabelSize(0.05);
		// mg2->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg2->GetXaxis()->CenterTitle();
		// mg2->GetYaxis()->CenterTitle();
			
		// TLegend* leg2 = new TLegend(0.2,0.15,0.35,0.35);
		// // leg2->SetTextAlign(12);
		// // leg2->SetFillColor(0);
		// // leg2->SetFillStyle(0);		
		// leg2->SetTextSize(0.04);
		
		// leg2->AddEntry(gg0,rname10);
		// leg2->AddEntry(gg3,rname13);
		// leg2->AddEntry(gg4,rname14);
		// leg2->AddEntry(gg5,rname15);
		
		
		// //leg2->DrawClone("Same");
		// leg2->Draw();
		
		
		
		
		
		// //*************************************************
		// mycanvas1->cd(2);
		// // gPad->SetLogy();
		// gPad->SetLogx();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.15);
		
		// // TGraph *rr3 = new TGraph(Bin,X.data(),R_fit3.data());
		// // TGraph *rr4 = new TGraph(Bin,X.data(),R_fit4.data());
		
		// // without first point whose momentum transfer = 0
		// TGraph *rr3 = new TGraph(Bin-1,XX.data(),R_fit33.data());
		// TGraph *rr4 = new TGraph(Bin-1,XX.data(),R_fit44.data());
		// TGraph *rr5 = new TGraph(XX_g4.size(),XX_g4.data(),R_fit_g4.data());
		
		
		// auto mg3 = new TMultiGraph();
		
		
		// rr4->SetMarkerStyle(20); 
		// rr4->SetMarkerSize(1.3);
		// rr4->SetMarkerColor(kRed);
		// //rr4->SetLineWidth(2);
		// rr4->SetLineColor(kRed);	
		// mg3->Add(rr4);
		
		
		// rr3->SetMarkerStyle(20);  
		// rr3->SetMarkerSize(0.7);
		// rr3->SetMarkerColor(kGreen);
		// //ratio3->SetLineWidth(2);
		// rr3->SetLineColor(kGreen);	
		// mg3->Add(rr3);
		
		// rr5->SetMarkerStyle(20);  
		// rr5->SetMarkerSize(0.7);
		// rr5->SetMarkerColor(kBlue);
		// //ratio3->SetLineWidth(2);
		// rr5->SetLineColor(kBlue);	
		// mg3->Add(rr5);
		
		
		// mg3->Draw("AP");
		// TString title3 = "Relative difference of FF^{2} compared to tabulated data for element " + s;
		// mg3->SetTitle(title3);		
		// mg3->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		// mg3->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg3->GetXaxis()->SetTitleSize(0.06);
		// mg3->GetYaxis()->SetTitleSize(0.06);
			
		// mg3->GetXaxis()->SetLabelSize(0.05);
		// mg3->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg3->GetXaxis()->CenterTitle();
		// mg3->GetYaxis()->CenterTitle();
		
		// // mg3->GetXaxis()->SetTitleOffset(1.2);	
		
		// TLegend* leg3 = new TLegend(0.15,0.7,0.35,0.9);
		// // leg3->SetTextAlign(12);
		// // leg3->SetFillColor(0);
		// leg3->SetFillStyle(0);		
		// leg3->SetTextSize(0.04);
		
		
		
		// leg3->AddEntry(rr3,rname13);
		// leg3->AddEntry(rr4,rname14);
		// leg3->AddEntry(rr5,rname15);

		
		// //leg3->DrawClone("Same");
		// leg3->Draw();
		
		
		// TString name2="plots/Fit_FF_finalCompare_2017VS2014/Ahisto_" + s + ".gif";
		// mycanvas1->Print(name2);
		// delete mycanvas1;
		// mycanvas1 = NULL;
		
  // }
  // plotAverageRatio(XXX, averageRVec1, averageRVec2,averageRVec5 );

	
	// std::ostringstream ost;	
	
	// // 9 parameters
	// for(int i=0; i<9; i++)
	// {
		
		// ost << "./FF2017_PP" << i <<".dat";
		// std::ofstream fout(ost.str(), ios::out);
		
		// fout<<0<<" "<<endl;
		// fout.setf(ios::scientific);
		
		// // for(int z = ZZ; z<=ZZ; z++)
		// for(int z = 1; z<=100; z++)
		// {
			
			// fout<<setprecision(9)<<PPP[i][z]<<", ";
			// if(z%10==0)
			// {
				// int beginZ = z-9;
				// fout<<" // "<<beginZ<<"-"<<z<<endl;
			// }
			
			
			
		// }
		// fout.close();
		// ost.str("");
		// ost.clear();	
		
	// }
	
			
	





// }

// for the first publication
void fit_formFactor_2017()
{
	gSystem->Exec("mkdir -p plots/Fit_FF_compare_2017");
	gSystem->Exec("mkdir -p plots/Fit_FF_finalCompare_2017VS2014");
	
	gROOT->Reset();
	gStyle->SetOptStat(0);
	gStyle->SetOptFit();
	
	ReadFit9Parameters();
   
	// return;

	Double_t x, y;   
	Double_t x1, x2, y1, y2; 
	Double_t ZZ0[101]={0};   
	Double_t PP0[101]={0};   
	Double_t PP1[101]={0};   
	Double_t PP2[101]={0};   
	Double_t PP3[101]={0};   
	Double_t PP4[101]={0};   
	Double_t PP5[101]={0};   
	Double_t PP6[101]={0};   
	Double_t PP7[101]={0};   
	Double_t PP8[101]={0};
	vector<double> PPP[9]; // 9 vectors, each vector has 101 elements
	vector<double> XXX(100); 
	vector<double> averageRVec1(100);
	vector<double> averageRVec2(100);
	vector<double> averageRVec5(100);
	for(int i=0; i<100; i++)
	{
		XXX[i] = i+1; // XXX contains Z atomic number
		averageRVec1[i] = 0;
		averageRVec2[i] = 0;
		averageRVec5[i] = 0;
	}
	
	for(int i = 0; i<9; ++i)
	{
		
		PPP[i].reserve(101);
		// PPP[i].push_back(0);
		PPP[i][0] = 0;
		// cout<<"ggggggggggg"<<PPP[i].capacity()<<" "<<PPP[i][0]<<endl;
	}
   // return;
	char line[200];  

	Double_t xxx[2000]={0};   
	Double_t yyy[2000]={0};   
	Double_t erx[2000]={0};   
	Double_t ery[2000]={0}; 
	Int_t N=0, nn=0; 
	Int_t k = 0;
	// Int_t ZZ = t;
	

	// for(Int_t i=ZZ; i<=ZZ; i++) 
	for(Int_t i=1; i<=1; i++) 
	{
		// if((i != 1) && (i != 13) && (i != 82)) continue;
		vector<double> X;
		vector<double> XX;
		vector<double> Y_tab;
		vector<double> Y_fit1; // real fit
		vector<double> Y_fit2; // modified fit after real fit
		vector<double> Y_fit3; // Geant4 fit
		vector<double> Y_fit4; // final fit (modified fit + geant4 fit)
		
		vector<double> R_fit1;
		vector<double> R_fit2;
		vector<double> R_fit3;
		vector<double> R_fit4;
		
		vector<double> R_fit33;  // to save the points without momentum transfer = 0
		vector<double> R_fit44;
		vector<double> R_fit55;
		k = i;
    // for(Int_t i=82; i<83; i++) {

		Int_t Z=i;
		cout <<  " " << endl;
		cout <<  "Next Element " << endl;
		cout <<  "Element " << Z  << endl;
		TString s = sInt(Z);
		// TString datafile="data/re-ff-" + s + ".dat";
		TString datafile="./epics2017/formFactor/re-ff-" + s + ".dat";
		// TString datafile="epics2014/formFactor/re-ff-" + s + ".dat";
		// TString datafile="epics2014/formFactor/g4/re-ff-" + s + ".dat";
		// string ffdata = datafile; 
    
    //OUT
    //TString ffname = "out_" + s + ".txt";       //output file
    //string fname = ffname;    
    //ofstream fout(fname.c_str(), ios::out);      
  
    //IN
    ifstream  data_file(datafile, ios::in );
    if(data_file.fail()){
      cout << "Error opening data file"  << endl;
    }else cout << "data file " << datafile << " is opened" << endl;

    Int_t pp=0;  // how much points to substract
    data_file.getline(line, 50); //cout << line << endl;
    data_file >> nn ;
    x1 = 1; y1 = 1;
    cout << "number of points: "<<nn << endl;
    Double_t P = 8;
    Double_t P0,P1,P2;
    Double_t lim = Z*Z/pow(2,P);  //* when Z<16, lim < 1
    Double_t limy = 1.e-6;
    // Double_t limy = Z*Z*1.e-15;
    Int_t n1 = 0;
    for (N = 0; N < nn; N++) 
	{
		if(!data_file) break;
		data_file >> x >> y;
		
		x*=1e14;  // to make the unit of momentum transfer cm-1
		y2 = y*y;
		X.push_back(x);
		Y_tab.push_back(y2);
		// if(x1 == 1)
		// {
			// cout<<N<<" zhuxin----"<<endl;
			// // x1=x;
		// }
	  
      if(x1 == 1 && y2 < lim){cout<<"--stop--"<<endl; x1=x; y1=y2;}   
      x2 = x;
      xxx[N] = x;   
      yyy[N] = y2;   
      erx[N] = 0;   
      ery[N] = y2*0.1*(1. + log10((Z*Z)/y2));
	  
	  // exceptions because erro=0.05 leads to better fit results
	  if( Z==29 || Z==30 ||Z==90 )
	  {
		  ery[N] = y2*0.05;
	  }
      
	  // printf("%d %.9e %.9e %.9e\n",N, x, y, yyy[N]);
	  
      // ery[N] = y2*0.05;
      if(0 == n1 && y2 < Z*Z*limy) {  n1 = N; cout<<"--test--"<<n1<<" "<<x<<endl;}
    }
	data_file.close();
	Int_t Bin = n1;
	
	//****************Read EPICS2014*******************begin
	Int_t num = 0;  
	Int_t ncols;
	double q, ff;
	Int_t loop = 0;
	char str[64] = "";
	
	char path2Format[128] = "./epics2014/formFactor/re-ff-%d.dat"; //prefix of the name of original data file
	char path2[128];	
	sprintf(path2,path2Format, Z);
	
		
	FILE * fp = fopen(path2,"r");

	while(1)  
	{	
		loop++;
		// if loop = 1 we read the first header line
		fgets (str, 64, fp);
		// cout<<str<<endl;
		if(loop ==2)
		{
			// now loop = 2, we read the second header line, namely the number of points
			num = stoi(str);  
			cout<<"number of form factor points:"<<num<<endl;
			break;
		}		
		
	}
	
	vector<double> X_g4;
	vector<double> XX_g4; // to remove the first point
	vector<double> Y_tab_g4;
	vector<double> Y_fit_g4;
	vector<double> R_fit_g4;
	for(Int_t i = 0;i<num;++i)
	{
		
		// read one line energy cross section
		ncols = fscanf(fp,"%lf %lf",&q,&ff); 
		if(q>xxx[Bin-1]) 
		{
			// printf("-----------%.9e %.9e\n", q, ff);
			break;
		}
		// printf("**********%.9e %.9e\n", q, ff);
		
		X_g4.push_back(q);
		Y_tab_g4.push_back(ff*ff);
	}
	fclose(fp);
	
	//****************Read EPICS2014*******************end
	
	
	
    
	
	// for(int i=0; i<nn;++i)
	// for(int i=0; i<Bin;++i)
	// {
		// cout<<i<<" "<<xxx[i]<<" "<<yyy[i]<<endl;
	// }
	
    // Bin = n1;
    cout <<  "Bin = " << Bin << ", xxx[Bin-1] = "<<xxx[Bin-1]<<endl;
    TCanvas *c = new TCanvas("c","GraphFit",800,50, 1000, 800);  
    // TCanvas *c = new TCanvas("c","GraphFit",.0, xxx[Bin], 1000, 800);  
	c->cd();
    P = 4 - 0.0157*Z;
    Double_t B=(pow(2.0,1.0/P)-1)/(x1*x1);
	
    // P2 = P;
	
    // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    // if (Z>2 && Z<=64){
      // P0 = 0.5*log(yyy[nn-3]/yyy[nn-1])/log(xxx[nn-1]/xxx[nn-3]);
    // }
	// if (Z>2 && Z<=64){
	// if (Z>2 && Z<=64){
	// // if (Z>=1 && Z<=64){
      // // P0 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // // P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    
	 // P1 = P0;
    
	// }
	
	// if (Z<=10){
      // //   P0 
      // P2 = P;
      // P1 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // }else if (Z>10 && Z<=64){
      // P2 = P;
      // P1 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
      // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
    // }else{
      // P2 = P;
      // P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P1 = P0;
    // }
	
	if (Z<=10)
	{
        // P0 
      P2 = P;
	  P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
	  P1 = P0;
	  if(Z ==3)
	  {
		  // cout<<"333333333333"<<endl;
		  P1 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
		  P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
	  }
    }
	else if (Z>10 && Z<=64)
	{
      P2 = P;
	  P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P0 = 0.5*log(yyy[nn-18]/yyy[nn-21])/log(xxx[nn-21]/xxx[nn-18]);
	  P1 = 0.5*log(yyy[n1-1]/yyy[n1-3])/log(xxx[n1-3]/xxx[n1-1]);
	  cout<<"zhuxin "<<yyy[n1-1]/yyy[n1-3]<<endl;
	  // P0 = P1;
     
    }
	else
	{
      P2 = P;
      P0 = 0.5*log(yyy[nn-1]/yyy[nn-3])/log(xxx[nn-3]/xxx[nn-1]);
      // P1 = P0;
	  P1 = 0.5*log(yyy[n1-3]/yyy[n1-1])/log(xxx[n1-1]/xxx[n1-3]);
    }
    cout <<  "B= " << B << "  P = " << P << "  P0 = " << P0 
	 << "  P1 = " << P1 << "  P2 = " << P2<< endl;
    if(B < 0.0) { B = 0.0; }
    TF1 *fitFcn = new TF1("fitFcn",fitf,xxx[0],xxx[Bin],9);
   
  
  
	if(Z == 2 || Z == 4 || Z == 5 || Z == 6 || Z == 13 || Z == 20 || Z == 22 || Z == 46  || Z == 48  || Z == 54
	|| Z == 55 || Z == 55 || Z == 58 || Z == 66 || Z == 68 || Z == 69 || Z == 70 || Z == 71 || Z == 72 
	|| Z == 85 || Z == 90 || Z == 92  || Z == 94 || Z == 99)	
	 {
		 fitFcn->SetParameters(Z,PP[1][Z],PP[2][Z],PP[3][Z],PP[5][Z],PP[6][Z],PP[7][Z], PP[8][Z]);
	 }	
	else
	{
		fitFcn->SetParameters(Z,Z*Z/6,Z*Z/6,B,B,B,P2,P1,P0); 
	}	 
		
	
    fitFcn->FixParameter(0,Z); 
    fitFcn->SetParLimits(1,Z*Z/10,Z*Z/2); 
    fitFcn->SetParLimits(3,B/1000,B*1000); 
    fitFcn->SetParLimits(4,B/1000,B*1000); 
    fitFcn->SetParLimits(6,P2/2,P2*2); 
    fitFcn->SetParLimits(7,P1/2,P1*2); 
    if(Z<=2){
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,B); 
      fitFcn->FixParameter(8,P0);  
    }
	else {
      fitFcn->SetParLimits(2,0,Z*Z/2); 
      fitFcn->SetParLimits(5,B/1000,B*1000); 
      fitFcn->SetParLimits(8,P0/2,P0*2); 
    }

	gPad->SetLogy();
	gPad->SetLogx();

    // TGraphErrors *gr = new TGraphErrors(nn, xxx, yyy, erx, ery); 
    TGraphErrors *gr = new TGraphErrors(Bin, xxx, yyy, erx, ery); 
    gr->SetTitle("FF Fit");
    gr->Draw("ALP*");
    gr->Fit(fitFcn);
	// return;
	
	
    Double_t p1 =  fitFcn->GetParameter(1);
    if(p1 < 1.e-8) { p1 = 0;}
    Double_t p2 =  fitFcn->GetParameter(2);
    if(p2 < 1.e-8) { p2 = 0;}
    Double_t p0 =  Z*Z - p1 - p2;
    Double_t p3 =  fitFcn->GetParameter(3);
    Double_t p4 =  fitFcn->GetParameter(4);
    Double_t p5 =  fitFcn->GetParameter(5);
    Double_t p6 =  fitFcn->GetParameter(6);
    Double_t p7 =  fitFcn->GetParameter(7);
    Double_t p8 =  fitFcn->GetParameter(8);

    if(p1 < 1.e-5) { p1 = 0;}
    if(p2 < 1.e-5) { p2 = 0;}

    PP0[Z]=p0;
    PP1[Z]=p1; 
    PP2[Z]=p2; 
    PP3[Z]=p3;
    PP4[Z]=p4; 
    PP5[Z]=p5; 
    PP6[Z]=p6; 
    PP7[Z]=p7;
    PP8[Z]=p8;


    c->Update();
    fitFcn->SetParameters(Z,PP1[Z],PP2[Z],PP3[Z],PP4[Z],PP5[Z],PP6[Z],PP7[Z],PP8[Z]); 
    fitFcn->FixParameter(0,Z); 
    fitFcn->SetParLimits(1,PP1[Z]/2,Z*Z/2); 
    fitFcn->SetParLimits(2,PP2[Z]/2,Z*Z/2); 
    fitFcn->SetParLimits(3,PP3[Z]/1000,PP3[Z]*1000); 
    fitFcn->SetParLimits(4,PP4[Z]/1000,PP4[Z]*1000); 
    fitFcn->SetParLimits(5,PP5[Z]/1000,PP5[Z]*1000); 
    fitFcn->SetParLimits(6,PP6[Z]/2,PP6[Z]*2); 
    fitFcn->SetParLimits(7,PP7[Z]/2,PP7[Z]*2); 
    fitFcn->SetParLimits(8,PP8[Z]/2,PP8[Z]*2); 
	
    if(Z<=2){
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,p5); 
      fitFcn->FixParameter(8,p8);  
    }
    if(p1 < 1.e-5) { 
      fitFcn->FixParameter(1,0); 
      fitFcn->FixParameter(4,p4); 
      fitFcn->FixParameter(7,p7);  
    }
    if(p2 < 1.e-5) { 
      fitFcn->FixParameter(2,0); 
      fitFcn->FixParameter(5,p5); 
      fitFcn->FixParameter(8,p8);  
    }
    gr->Fit(fitFcn);
 

	p1 =  fitFcn->GetParameter(1);
	if(p1 < 1.e-5) { p1 = 0;}
	p2 =  fitFcn->GetParameter(2);
	if(p2 < 1.e-5) { p2 = 0;}
	p0 =  Z*Z - p1 - p2;
	p3 =  fitFcn->GetParameter(3);
	p4 =  fitFcn->GetParameter(4);
	p5 =  fitFcn->GetParameter(5);
	p6 =  fitFcn->GetParameter(6);
	p7 =  fitFcn->GetParameter(7);
	p8 =  fitFcn->GetParameter(8);
	
	

	PP0[Z]=p0;
	PP1[Z]=p1; 
	PP2[Z]=p2; 
	PP3[Z]=p3;
	PP4[Z]=p4; 
	PP5[Z]=p5; 
	PP6[Z]=p6; 
	PP7[Z]=p7;
	PP8[Z]=p8;
	
	// to make writing easier (begin)
	double ppp[9];
	ppp[0] = p0;
	ppp[1] = p1;
	ppp[2] = p2;
	ppp[3] = p3;
	ppp[4] = p4;
	ppp[5] = p5;
	ppp[6] = p6;
	ppp[7] = p7;
	ppp[8] = p8;
	
	
	for(int i = 0; i<9; ++i)
	{
		
		//replace new fitting paramters with previous fitting parameters for the following elements,
		// because the new fitting can not perform better than old		
		PPP[i][Z] = ppp[i];
		// cout<<"ggggggggggg "<<PPP[i].capacity()<<" "<<PPP[i][0]<<endl;
		
		// if( Z==3 || Z==13 || Z==19 || Z==20 || Z==21 || Z==22 || Z==46 || Z==52 || Z==56 || Z==58 || Z==63
			// || Z==66 || Z==68 || Z==74 || Z==99)
			
		if( Z==3 || Z==19 || Z==21 || Z==36 ||Z==44 || Z==45 ||Z==52 || Z==56 || Z==63 || Z==74)
		{
			PPP[i][Z] = PP[i][Z];
		}
	}	
		
    // to make writing easier (end)
		gr->SetLineColor(kBlue);
		// gr->Draw("ALP* SAME");
		
		TString name="plots/Fit_FF_2017/Ahisto_" + s + ".gif";
		c->Print(name);
		delete c;
		c = NULL;
		
		TCanvas *mycanvas = new TCanvas("mycanvas",s,800,50, 1000, 800);
		mycanvas->Divide(1,2);
		mycanvas->cd(1);
		gPad->SetLogy();
		gPad->SetLogx();
		cout<<"--real fit: "<<fitFcn->GetParameter(0)<<" "<<fitFcn->GetParameter(1)<<" "<<fitFcn->GetParameter(2)<<endl;
		cout<<"--modified fit: "<<p0<<" "<<p1<<" "<<p2<<endl<<endl;
		cout<<"Previous fitting parameters: PP0 = "<<PP[0][Z]<<" PP1 = "<<PP[1][Z]<<" PP2 = "<<PP[2][Z]<<" PP3 = "<<PP[3][Z]<<
		" PP4 = "<<PP[4][Z]<<" PP5 = "<<PP[5][Z]<<" PP6 = "<<PP[6][Z]<<" PP7 = "<<PP[7][Z]<<" PP8 = "<<PP[8][Z]<<endl;
		//*******************
		
		
		double totalR1 = 0;
		double totalR2 = 0;
		// for(int i = 0; i< nn; i++)
		for(int i = 0; i< Bin; i++)
		{
			
			double y1 = fitFcn->Eval(X[i]); //real fit
			// double PPP0 = fitFcn->GetParameter(0);
			// double y0 = (PPP0*PPP0 - PP1[Z] - PP2[Z])/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
				
			// modified fit (old verison, but false)
			// double y2 = (PP0[Z]*PP0[Z] - PP1[Z] - PP2[Z])/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						// PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						// PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
						
			// modified fit based on real fit			
			double y2 = PP0[Z]/pow(1+PP3[Z]*X[i]*X[i],PP6[Z]) +
						PP1[Z]/pow(1+PP4[Z]*X[i]*X[i],PP7[Z]) +
						PP2[Z]/pow(1+PP5[Z]*X[i]*X[i],PP8[Z]);
						
			// double y3 = (PP[0][Z]*PP[0][Z] - PP[1][Z] - PP[2][Z])/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						// PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						// PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
			
			// geant4 fit, using EPICS2017 data
			double y3 = PP[0][Z]/pow(1+PP[3][Z]*X[i]*X[i],PP[6][Z]) +
						PP[1][Z]/pow(1+PP[4][Z]*X[i]*X[i],PP[7][Z]) +
						PP[2][Z]/pow(1+PP[5][Z]*X[i]*X[i],PP[8][Z]);
						
			// final fit for 2017 PPP[i][Z], which is the combination of 5% errors and geant4 fit(2014)
			double y4 = PPP[0][Z]/pow(1+PPP[3][Z]*X[i]*X[i],PPP[6][Z]) +
						PPP[1][Z]/pow(1+PPP[4][Z]*X[i]*X[i],PPP[7][Z]) +
						PPP[2][Z]/pow(1+PPP[5][Z]*X[i]*X[i],PPP[8][Z]);			
			
			double r1 = (y1-Y_tab[i])/Y_tab[i]*100;
			double r2 = (y2-Y_tab[i])/Y_tab[i]*100;
			double r3 = (y3-Y_tab[i])/Y_tab[i]*100;
			double r4 = (y4-Y_tab[i])/Y_tab[i]*100;
			
			
			
			
			totalR1 +=abs(r4);
			totalR2 +=abs(r3);
			Y_fit1.push_back(y1);		
			Y_fit2.push_back(y2);
			Y_fit3.push_back(y3);			
			Y_fit4.push_back(y4);
			
			
			R_fit1.push_back(r1);
			R_fit2.push_back(r2);
			R_fit3.push_back(r3);
			R_fit4.push_back(r4);
			if(i!=0)  // to remove the first point FF = 0
			{
				R_fit33.push_back(r3);
				R_fit44.push_back(r4);
				XX.push_back(X[i]);
				// printf("******%d %.9e %.9e\n", i, X[i], r4);
			}
			
			// printf("____%d %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y2);
			// printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y0, y2);
			// printf("____%d %.9e %.9e %.9e %.9e %.9e\n", i, X[i], Y_tab[i], y1, y2, y3);
			// printf("____%d %.9e %.9e\n", i, X[i], r4);
		}
		double totalR5 = 0;
		// geant4 fit using EPICS2014
		for(int i = 0; i<X_g4.size(); i++)
		{
			// geant4 fit, using EPICS2017 data
			double y5 = PP[0][Z]/pow(1+PP[3][Z]*X_g4[i]*X_g4[i],PP[6][Z]) +
						PP[1][Z]/pow(1+PP[4][Z]*X_g4[i]*X_g4[i],PP[7][Z]) +
						PP[2][Z]/pow(1+PP[5][Z]*X_g4[i]*X_g4[i],PP[8][Z]);
						
			double r5 = (y5-Y_tab_g4[i])/Y_tab_g4[i]*100;
			totalR5 +=abs(r5);
			if(i ==0) continue;
			// starting from i = 1, in order not to show the first point, the size of XX_g4 = XX_g4.size()
			XX_g4.push_back(X_g4[i]);
			Y_fit_g4.push_back(y5);
			R_fit_g4.push_back(r5);
			printf("********%.9e %.9e %.9e %.9e\n", X_g4[i], Y_tab_g4[i], y5, r5);
		}
		
		
		double averageR1 = totalR1/Bin;   //new fit using EPICS2017, note that average contains the first point
		double averageR2 = totalR2/Bin;   // old fit using EPICS2017
		double averageR5 = totalR5/X_g4.size();   // odl fit using EPICS2014
		printf("***%.9e %.9e\n", totalR1, averageR1);
		printf("***%.9e %.9e\n", totalR2, averageR2);
		printf("***%.9e %.9e\n", totalR5, averageR5);
		averageRVec1[Z-1] = averageR1;
		averageRVec2[Z-1] = averageR2;
		averageRVec5[Z-1] = averageR5;
		
		TGraph *graph0 = new TGraph(Bin,X.data(),Y_tab.data());
		TGraph *graph1 = new TGraph(Bin,X.data(),Y_fit1.data());
		TGraph *graph2 = new TGraph(Bin,X.data(),Y_fit2.data());
		TGraph *graph3 = new TGraph(Bin,X.data(),Y_fit3.data());
		TGraph *graph4 = new TGraph(XX_g4.size(),XX_g4.data(),Y_fit_g4.data());
		
		auto mg = new TMultiGraph();
		
		
		graph2->SetMarkerStyle(24);  // modified fit
		graph2->SetMarkerSize(1.3);
		graph2->SetMarkerColor(kRed);
		//graph2->SetLineWidth(2);
		graph2->SetLineColor(kRed);	
		mg->Add(graph2);
		
		graph1->SetMarkerStyle(24);  // real fit
		graph1->SetMarkerSize(1.0);
		graph1->SetMarkerColor(kBlue);
		//graph1->SetLineWidth(2);
		graph1->SetLineColor(kBlue);	
		mg->Add(graph1);	
		
		
		graph3->SetMarkerStyle(20);  // geant4 fit
		graph3->SetMarkerSize(0.7);
		graph3->SetMarkerColor(kYellow);
		//graph2->SetLineWidth(2);
		graph3->SetLineColor(kYellow);	
		mg->Add(graph3);
		
		
		graph4->SetMarkerStyle(20);  // geant4 fit
		graph4->SetMarkerSize(0.7);
		graph4->SetMarkerColor(kMagenta);
		//graph2->SetLineWidth(2);
		graph4->SetLineColor(kMagenta);	
		mg->Add(graph4);
		
		
		graph0->SetMarkerStyle(20);  // tabulated data
		graph0->SetMarkerSize(0.4);
		graph0->SetMarkerColor(kTeal+4);
		//graph1->SetLineWidth(2);
		graph0->SetLineColor(kTeal+4);	
		mg->Add(graph0);
		
		mg->Draw("AP");
		TString title = "EPDL2017: Fif of FF{2} using 2014 parameters and new fit() fitted FF(square) VS tabulated FF(square) for element " + s;
		mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Momentum transfer");
		mg->GetYaxis()->SetTitle("Square of FF");
		
		
		TLegend* leg = new TLegend(0.15,0.7,0.35,0.9);
		// leg->SetTextAlign(12);
		// leg->SetFillColor(0);
		leg->SetFillStyle(0);		
		leg->SetTextSize(0.04);
		
		TString rname10 = "Tabulated data";
		TString rname11 = "Real fit";
		TString rname12 = "Modified fit";
		TString rname13 = "Geant4 fit using EPICS2017";
		TString rname14 = "New fit";
		TString rname15 = "Geant4 fit using EPICS2014";
		
		leg->AddEntry(graph0,rname10);
		leg->AddEntry(graph1,rname11);
		
		
		leg->AddEntry(graph2,rname12);
		leg->AddEntry(graph3,rname13);
		leg->AddEntry(graph4,rname15);
		// leg->AddEntry(graph24,rname24);
		
		//leg->DrawClone("Same");
		leg->Draw();
		
		
		
		
		
		//*************************************************
		mycanvas->cd(2);
		// gPad->SetLogy();
		gPad->SetLogx();
		
		TGraph *ratio1 = new TGraph(Bin,X.data(),R_fit1.data());
		TGraph *ratio2 = new TGraph(Bin,X.data(),R_fit2.data());
		TGraph *ratio3 = new TGraph(Bin,X.data(),R_fit3.data());
		TGraph *ratio4 = new TGraph(XX_g4.size(),XX_g4.data(),R_fit_g4.data());
		auto mg1 = new TMultiGraph();
		
		
		
		
		
		ratio2->SetMarkerStyle(24); 
		ratio2->SetMarkerSize(1.3);
		ratio2->SetMarkerColor(kRed);
		//ratio2->SetLineWidth(2);
		ratio2->SetLineColor(kRed);	
		mg1->Add(ratio2);
		
		ratio1->SetMarkerStyle(24);  
		ratio1->SetMarkerSize(1.);
		ratio1->SetMarkerColor(kBlue);
		//ratio1->SetLineWidth(2);
		ratio1->SetLineColor(kBlue);	
		mg1->Add(ratio1);
		
		ratio3->SetMarkerStyle(20);  
		ratio3->SetMarkerSize(0.7);
		ratio3->SetMarkerColor(kYellow);
		//ratio3->SetLineWidth(2);
		ratio3->SetLineColor(kYellow);	
		mg1->Add(ratio3);
		
		ratio4->SetMarkerStyle(20);  
		ratio4->SetMarkerSize(0.7);
		ratio4->SetMarkerColor(kMagenta);
		//ratio4->SetLineWidth(2);
		ratio4->SetLineColor(kMagenta);	
		mg1->Add(ratio4);
		
		mg1->Draw("AP");
		TString title1 = "EPDL2017: Relative difference of real fitted FF(square) + modified FF(square) for element " + s;
		mg1->SetTitle(title);		
		mg1->GetXaxis()->SetTitle("Momentum transfer");
		mg1->GetYaxis()->SetTitle("Relative difference (%)");
		
		TLegend* leg1 = new TLegend(0.15,0.7,0.35,0.9);
		// leg1->SetTextAlign(12);
		// leg1->SetFillColor(0);
		leg1->SetFillStyle(0);		
		leg1->SetTextSize(0.04);
		
		// TString rname11 = "Real fit";
		// TString rname12 = "Modified fit";
		
		leg1->AddEntry(ratio1,rname11);
		// leg1->AddEntry(graph14,rname14);
		
		leg1->AddEntry(ratio2,rname12);
		leg1->AddEntry(ratio3,rname13);
		leg1->AddEntry(ratio4,rname15);
		
		//leg1->DrawClone("Same");
		leg1->Draw();
		
		
		TString name1="plots/Fit_FF_compare_2017/Ahisto_" + s + ".gif";
		mycanvas->Print(name1);
		delete mycanvas;
		mycanvas = NULL;
		
		//******************************
		// for the publication begin
		TCanvas *mycanvas1 = new TCanvas("mycanvas1",s,800,50, 800, 400);
		gPad->SetLogx();
		gPad->SetGrid();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		
		
		
		// TGraph *rr3 = new TGraph(Bin,X.data(),R_fit3.data());
		// TGraph *rr4 = new TGraph(Bin,X.data(),R_fit4.data());
		
		// without first point whose momentum transfer = 0
		TGraph *rr3 = new TGraph(Bin-1,XX.data(),R_fit33.data());
		TGraph *rr4 = new TGraph(Bin-1,XX.data(),R_fit44.data());
		TGraph *rr5 = new TGraph(XX_g4.size(),XX_g4.data(),R_fit_g4.data());
		
		
		auto mg3 = new TMultiGraph();
	
		
		
			
		// new fittig
		rr4->SetMarkerStyle(24); 
		rr4->SetMarkerSize(1.2);
		rr4->SetMarkerColor(kRed);
		//rr4->SetLineWidth(2);
		rr4->SetLineColor(kRed);	
		mg3->Add(rr4);
		
		
		rr3->SetMarkerStyle(21);  
		rr3->SetMarkerSize(0.8);
		rr3->SetMarkerColor(kBlue);
		//ratio3->SetLineWidth(2);
		rr3->SetLineColor(kBlue);	
		mg3->Add(rr3);
		
		rr5->SetMarkerStyle(20);  
		rr5->SetMarkerSize(0.7);
		rr5->SetMarkerColor(kBlue);
		//ratio3->SetLineWidth(2);
		rr5->SetLineColor(kBlue);	
		// mg3->Add(rr5);
		
		
		mg3->Draw("AP");
		TString title3 = "Relative difference of FF^{2} compared to tabulated data for element " + s;
		// mg3->SetTitle(title3);		
		mg3->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		mg3->GetYaxis()->SetTitle("Relative difference (%)");
		
		// mg3->GetXaxis()->SetTitleSize(0.06);
		// mg3->GetYaxis()->SetTitleSize(0.06);
			
		// mg3->GetXaxis()->SetLabelSize(0.05);
		// mg3->GetYaxis()->SetLabelSize(0.05);
		
		
		mg3->GetXaxis()->CenterTitle();
		mg3->GetYaxis()->CenterTitle();
		
		mg3->GetXaxis()->SetTitleOffset(1.5);
		mg3->GetYaxis()->SetTitleOffset(1.2);
		
		TGaxis *axisX = new TGaxis(TMath::Power(10, gPad->GetUxmin()),gPad->GetUymax(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg3->GetXaxis()->GetXmin(),
		mg3->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw();
		
		
		TGaxis *axisY = new TGaxis(TMath::Power(10, gPad->GetUxmax()),gPad->GetUymin(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg3->GetYaxis()->GetXmin(),
		mg3->GetYaxis()->GetXmax(), 510,"U+");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
		
		
		
		// mg3->GetXaxis()->SetTitleOffset(1.2);	
		
		TLegend* leg3 = new TLegend(0.15,0.7,0.35,0.9);
		// leg3->SetTextAlign(12);
		// leg3->SetFillColor(0);
		leg3->SetFillStyle(0);		
		leg3->SetTextSize(0.04);
		
		
		
		leg3->AddEntry(rr3,rname13);
		leg3->AddEntry(rr4,rname14);
		// leg3->AddEntry(rr5,rname15);

		
		//leg3->DrawClone("Same");
		// leg3->Draw();
		
		
		TString name2="plots/Fit_FF_finalCompare_2017VS2014/Ahisto_publication_" + s + ".png";
		mycanvas1->Print(name2);
		delete mycanvas1;
		mycanvas1 = NULL;
		
  }
  
  
	plotAverageRatio(XXX, averageRVec1, averageRVec2,averageRVec5 );

	FILE* out = fopen("AbsoluteAverageDiffereceOfFits_newFitUsing2017_oldFitUsing2017_oldFitUsing2014.dat", "w");
	
  
    for(int i=0; i<100;i++)
	{
		fprintf(out,"%d\t%.9e\t%.9e\t%.9e\n", i+1,averageRVec1[i],averageRVec2[i], averageRVec5[i]);
		
	}
	fclose(out);
	
	std::ostringstream ost;	
	
	// 9 parameters
	for(int i=0; i<9; i++)
	{
		
		ost << "./FF2017_PP" << i <<".dat";
		std::ofstream fout(ost.str(), ios::out);
		
		fout<<0<<" "<<endl;
		fout.setf(ios::scientific);
		
		// for(int z = ZZ; z<=ZZ; z++)
		for(int z = 1; z<=100; z++)
		{
			
			fout<<setprecision(9)<<PPP[i][z]<<", ";
			if(z%10==0)
			{
				int beginZ = z-9;
				fout<<" // "<<beginZ<<"-"<<z<<endl;
			}
			
			
			
		}
		fout.close();
		ost.str("");
		ost.clear();	
		
	}
	
			
	





}


