void plotAverageRatio()
{
	gROOT->Reset();
	gStyle->SetOptStat(0);
	gStyle->SetOptFit();
	
	
	vector<double> X;
	vector<double> averageR1;
	vector<double> averageR2;
	vector<double> averageR5;
	std::ostringstream ost;
	double z, r1, r2, r5;
	ost <<"AbsoluteAverageDiffereceOfFits_newFitUsing2017_oldFitUsing2017_oldFitUsing2014_final.dat";
	std::ifstream fin(ost.str().c_str());
	for(int i = 0; i<100;i++)
	{
		fin >> z >> r1>>r2>>r5;
		averageR1.push_back(r1);
		averageR2.push_back(r2);
		averageR5.push_back(r5);
		
		X.push_back(z);
	}

	fin.close();
	
	
	// calculate the factor of fit precision improved by new fit method
	double sum;
	for(int i = 0; i<100;i++)
	{
		sum+=abs((averageR2[i]/averageR1[i]));
		
	}
	
	printf("------------factor on average of fit = %.9e\n", sum/100);
	
	
	
	TCanvas *mycanvas2 = new TCanvas("mycanvas2","average ratio",800,50, 400, 400);
	mycanvas2->cd();
	// gPad->SetLogy();
	// gPad->SetLogx();
	mycanvas2->SetGrid();
	gPad->SetGrid();
	gPad->SetBottomMargin(0.15);
	gPad->SetLeftMargin(0.15);
		
	TGraph *average1 = new TGraph(X.size(),X.data(),averageR1.data()); 
	TGraph *average2 = new TGraph(X.size(),X.data(),averageR2.data()); 
	TGraph *average5 = new TGraph(X.size(),X.data(),averageR5.data()); 
	
	auto mg = new TMultiGraph();
	
	
	
	average2->SetMarkerStyle(21);  // modified fit
	average2->SetMarkerSize(0.8);
	average2->SetMarkerColor(kBlue);
	//average2->SetLineWidth(2);
	average2->SetLineColor(kBlue);
	mg->Add(average2);
	
	
	
	
	average1->SetMarkerStyle(24);  // modified fit
	average1->SetMarkerSize(1.2);
	average1->SetMarkerColor(kRed);
	//average1->SetLineWidth(2);
	average1->SetLineColor(kRed);
	mg->Add(average1);
	
	average5->SetMarkerStyle(24);  // modified fit
	average5->SetMarkerSize(1.5);
	average5->SetMarkerColor(kGreen);
	//average5->SetLineWidth(2);
	average5->SetLineColor(kGreen);
	// mg->Add(average5);
	
	mg->Draw("AP");
	TString title2 = "Average absolute difference of fits according to Z";
	// mg->SetTitle(title2);		
	mg->GetXaxis()->SetTitle("Atomic number (Z)");
	mg->GetYaxis()->SetTitle("Mean absolute relative difference in FF^{2} (%)");
	
	// mg->GetXaxis()->SetTitleSize(0.06);
	// mg->GetYaxis()->SetTitleSize(0.06);
		
	// mg->GetXaxis()->SetLabelSize(0.05);
	// mg->GetYaxis()->SetLabelSize(0.05);
	
	mg->GetXaxis()->CenterTitle();
	mg->GetYaxis()->CenterTitle();
	
	mg->GetXaxis()->SetTitleOffset(1.5);
	mg->GetYaxis()->SetTitleOffset(1.5);
	mg->GetXaxis()->SetLimits(0, 101);
		
	TGaxis *axisX = new TGaxis(0,gPad->GetUymax(),
	101, gPad->GetUymax(),
	mg->GetXaxis()->GetXmin(),
	mg->GetXaxis()->GetXmax(), 510,"U-");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisX->Draw("");
	
	
	TGaxis *axisY = new TGaxis(101,gPad->GetUymin(),
	101, gPad->GetUymax(),
	mg->GetYaxis()->GetXmin(),
	mg->GetYaxis()->GetXmax(), 510,"U+");
	// axis->SetLineColor(kRed);
	// axis->SetLabelColor(kRed);
	axisY->Draw();
		
	
	
	TLegend* leg = new TLegend(0.55,0.75,0.9,0.9);
	// leg->SetTextAlign(12);
	// leg->SetFillColor(0);
	leg->SetFillStyle(0);		
	leg->SetTextSize(0.04);
	
	TString rname1 = "New fit";
	TString rname2 = "Geant4 fit using EPICS2017";
	TString rname5 = "Geant4 fit using EPICS2014";
	
	
	leg->AddEntry(average1,rname1);
	leg->AddEntry(average2,rname2);
	leg->AddEntry(average5,rname5);
	// leg->AddEntry(graph24,rname24);
	
	//leg->DrawClone("Same");
	// leg->Draw();
	
	
	mycanvas2->Print("plots/AverageRatioOfFits_2014_2017.png");
	// delete mycanvas2;
	// mycanvas2 = NULL;
	
	FILE* file = fopen("plots/average", "w");
	for(int i = 0; i<X.size();i++)
	{
		fprintf(file, "%.1e %.9e %.9e \n",X[i], averageR1[i], averageR2[i]);
	}
	
	fclose(file);
	
}
