// **************************************************************************
// ROOT macro: plot_total.c
// Plots the figures of total pair production cross section data. 
// There is one figure (now in png format, it can be modified) per element.
// -	cross section data of EPICS2014 (Z: 1-100) 
// -	cross section data of Livermore (Z: 1-99)   
// -	comparison of cross section data between Livermore and EPICS2014 (Z: 1-99) 
// The generated figures are saved in the corresponding directory:
// -	plots/total/comparison
// -	plots/total/epics2017
// -	plots/total/livermore

// Authors: Zhuxin LI @CENBG,France
// 2019.12.09
// **************************************************************************
TString sInt(Int_t number)
  {
    stringstream ss;
    ss << number;
	TString ts = ss.str();
    return ts;
  }
TString sDouble(Double_t number)
  {
    stringstream ss;
	ss << number;
    TString ts = ss.str();
    return ts;
  }
bool IsEqual(double a,double b , double eps,double releps)
{
	if(a==b)
	{
		return true;
	}
	
	if(fabs(a-b)<eps)
	{
      return true;
	}
	
	if(fabs(a-b)<=releps*fabs(b))
	{
		return true;
	}
 
	
	
	return false;
}
double eps=1e-10;//absolut difference
double releps=1e-9;//relative difference
 

 struct RatioInfo
 {
	 int z;
	 double ratioMax;
	 
	  
	 
 };
 
int results=0;
int results1=0;
std::vector<int> resultsV;
int results2=0;
int results3=0;
int results4=0;
int results5=0;
std::vector<int> results5V;
std::vector<RatioInfo> ratioMaxVec;



// void plotComparison(Int_t z, char*dir1, char*dir2)
// {
	// cout<<"-----element = "<<z<<endl;
	// gROOT->Reset();
		
	// TString S = sInt(z); 
	// TString title;
	// title = "Form factor of Rayleigh scattering for element Z = " + S;
		
		
	// Int_t num1 = 0;  
	// Int_t num2 = 0; 
	
	
	// Int_t ncols;
	// double e, cs;
	// Int_t loop = 0;
	// char str[64] = "";
	
	// FILE * fp1 = fopen(dir1,"r");
	
		// while(1)  
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp1);
			// // cout<<str<<endl;
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num1 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num1<<endl;
				// break;
			// }		
			
		// }
		
		// // double x_1[num1];		
		// // double y_1[num1]; 
		
		
		// std::vector<double>  x_1;
		// std::vector<double>  y_1;
		
		// bool test =true;
		// for(Int_t i = 0;i<num1;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			// // x_1[i]=e;   // keep energy
			// // y_1[i]=cs;  // keep cross section
			// x_1.push_back(e*1e14);  
			// y_1.push_back(cs);
			
			
			// // printf("%.9e %.9e\n",x_1[i],y_1[i]);
		// }
		// fclose(fp1);
		// // cout<<endl;
		
		
		
		
		
		
		// FILE * fp2 = fopen(dir2,"r");		
		// loop =0;
		
		// while(1)
		// {	
			// loop++;
			// // if loop = 1 we read the first header line
			// fgets (str, 64, fp2);
			// if(loop ==2)
			// {
				// // now loop = 2, we read the second header line, namely the number of points
				// num2 = stoi(str);  
				// // cout<<"number of total pair production points:"<<num2<<endl;
				// break;
			// }		
			
		// }
		

		// std::vector<double>  x_2;
		// std::vector<double>  y_2;
		
		
		// for(Int_t i = 0;i<num2;++i)
		// {
			// // read one line energy cross section
			// ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			// // x_2[i]=e; // keep energy
			// // y_2[i]=cs; // keep cross section
			
			// x_2.push_back(e);  
			// y_2.push_back(cs);
			
		// }
		// fclose(fp2);
		
		// std::vector<double> r;  // ratio (%): (EPICS2017-Livermore)/Livermore *100 ;
	
		// // for(Int_t j=0;j<num1;++j) //EPICS2017  x_1
		// // {
			// // // printf(s"%d %.9e \n", j+1, x_1[j]);
		// // }
		
		// // for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		// // {
			// // // printf("%d %.9e \n", i+1, x_2[i]);
			// // if(i ==4)
			// // {
				// // printf("%d %.9e \n", i+1, x_2[i]);
			// // }
			// // if(x_2[4]==x_1[6]) 
			// // {
				// // printf("yes");
			// // }
			// // printf("%d %.9e %.9e\n", i+1, x_2[4], x_1[6]);
		// // }
		// double ratioMax = 0;
		// for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		// {
			// bool isFound = false;
			
			// for(Int_t j=0;j<num1;++j) //EPICS2017  x_1
			// {
				// // if(j ==6 && i ==4) printf("%d %.9e %.9e \n", j+1, x_1[j], x_2[i]);
				// if(IsEqual(x_2[i],x_1[j], eps, releps ))
				// {	
					// // x_4[num4] = x_2[i];
					// // printf("%d %d %.9e %.9e \n", i+1, j+1, x_1[j], x_2[i]);
					
						
					// double ratio = (y_1[j] - y_2[i])/y_2[i]*100; // cout<<x_1[j]<<"===="<<r[num4]<<endl;
					// r.push_back(ratio);
					// // printf("%d %.9e %.9e %.9e %.9e %.9e\n", i, x_1[j], x_2[i],y_1[j], y_2[i], ratio );
					// // flag++;
					// // num4++;
					// //cout<<i<<"-----EPICS2017=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					// isFound = true;
					
					// if(abs(ratio)>abs(ratioMax)) ratioMax = ratio;
					// break;
					
				// }
				
			// }
			// if(!isFound) 
			// {
				// printf("%d %.9e *********************Not found\n", i+1, x_2[i]);
			// }
				
		
				
		// }
		
		// RatioInfo ratioInfo;
		// ratioInfo.z = z;
		// ratioInfo.ratioMax = ratioMax;
		// ratioMaxVec.push_back(ratioInfo);
		
		// // return;
		
		// // for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		// // {
			// // printf("%d %.9e %.9e\n", i+1, x_2[i], r[i]);
		// // }
		
		
		// TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",600, 10, 1000, 800);
		
		// mycanvas->SetGrid();
		// mycanvas->Divide(1,2);
		// //TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// // TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// // TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// // pad1->Draw();
		// // pad2->Draw();
		
		// // pad2->cd();
		// // TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// // TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// // pad21->Draw();
		// // pad22->Draw();
		
		
		// mycanvas->cd(1);
		// gPad->SetGrid();
		// gPad->SetLogx();
		// // gPad->SetLogy();
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetLeftMargin(0.01);
		// //gPad->SetLogy();
					
		// // TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// // TGraph *graph2 = new TGraph(num2,x_2,y_2);
		// TGraph *graph1 = new TGraph(x_1.size(),x_1.data(),y_1.data());
		// TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),y_2.data());
		
		// auto mg = new TMultiGraph();
		// //set graph parameters of livermore
		// graph2->SetMarkerStyle(4);  //blue circle
		// graph2->SetMarkerSize(0.7);
		// graph2->SetMarkerColor(4);
		// graph2->SetLineColor(4);
		
		// mg->Add(graph2);
	   
		
		// //set graph parameters of EPICS2014
		// graph1->SetMarkerStyle(7);  // red point
		// graph1->SetMarkerSize(2);
		// graph1->SetMarkerColor(2);
		// //graph1->SetLineWidth(2);
		// graph1->SetLineColor(2);	
		// mg->Add(graph1);
		// mg->Draw("APL");
				
		// mg->SetTitle(title);		
		// mg->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		// mg->GetYaxis()->SetTitle("Form factor");
		
		// mg->GetXaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleSize(0.06);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		
		
		// mg->GetXaxis()->CenterTitle();
		// mg->GetYaxis()->CenterTitle();
		
		
		
		
		
		// // graph2->SetMaximum(5e-25); 
		// // graph2->SetMinimum(1e-35); 
		
		
		// TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// // leg->SetTextAlign(12);
		// leg->SetFillColor(0);	
		// leg->SetTextSize(0.04);
		
		
		// TString Tnum1 = sInt(x_1.size());		
		// TString Tnum2 = sInt(x_2.size());	
		
		// TString name1 = "EPDL2017 - "+ Tnum1 + " points";
		// TString name2 = "Livermore - "+ Tnum2 + " points";		
		
		// leg->AddEntry(graph1,name1);
		// leg->AddEntry(graph2,name2);
		// //leg->DrawClone("Same");
		// leg->Draw();
		
		
		
		// mycanvas->cd(2);
		// gPad->SetLogx();		
		// // gPad->SetTopMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetBottomMargin(0.15);
		// // gPad->SetGrid();
		// // gStyle->SetTitleW(0.9);  //per cent of the pad width
		// // gStyle->SetTitleH(0.9);
		// // gStyle->SetTitleFontSize(0.9);
		
		// // // pad21->SetLeftMargin(0.10); //10%
		
		
		// char nameRatio[100] = "Relative difference of EPICS2017 compared to EPICS2014";	
		
		// TGraph *ratio = new TGraph(x_2.size(),x_2.data(),r.data());
		// auto mg1 = new TMultiGraph();
		// ratio->SetMarkerStyle(8);
		// ratio->SetMarkerSize(0.5);
		// ratio->SetMarkerColor(2);
		// ratio->SetLineColor(2);
		// mg1->Add(ratio);
		// mg1->Draw("AP");
		
		// mg1->SetTitle(nameRatio);
		// mg1->Draw();
		// mg1->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		// mg1->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleOffset(0.9);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
			
		// mg1->GetXaxis()->CenterTitle();
		// mg1->GetYaxis()->CenterTitle();
		
	
		
		// // TLatex latex;
		// // latex.SetTextSize(0.05);
		// // latex.SetTextAlign(22);
		// // latex.DrawLatexNDC(0.7,0.8,"RD = #frac{EPICS2017-EPICS2014}{EPICS2014} x 100");
		
		
		// // TString Tflag = sInt(flag);	
		// // Tflag += " points in comparison";
		// // latex.SetTextColor(2);
		// // latex.DrawLatexNDC(0.7,0.7,Tflag);
		
		
		
		
		// // // TLegend* leg212 =  new TLegend(0.12,0.7,0.3,0.88);
		// // // TString Tnum4 = sInt(num2);
		// // // TString name4 = Tnum4 + " points in comparison";		
		// // // leg212->AddEntry(ratio,name4);
		// // // leg212->SetTextAlign(22);
		// // // leg212->SetFillStyle(0);
		// // // leg212->Draw();
		// // // leg212->SetTextSize(0.05);
		
		
		
		
		// // //***********(begin)for the zoomin of the ratio 
		
		
		
		// mycanvas->Print("plots/formfactor/2014vs2017-re-ff-"+ S +".png");
		// mycanvas->Close();
		
		
// }


void plotComparison_for_publication(Int_t z, char*dir1, char*dir2)
{
	cout<<"-----element = "<<z<<endl;
	gROOT->Reset();
		
	TString S = sInt(z); 
	TString title;
	title = "Form factor of Rayleigh scattering for element Z = " + S;
		
		
	Int_t num1 = 0;  
	Int_t num2 = 0; 
	
	
	Int_t ncols;
	double e, cs;
	Int_t loop = 0;
	char str[64] = "";
	
	FILE * fp1 = fopen(dir1,"r");
	
		while(1)  
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp1);
			// cout<<str<<endl;
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num1 = stoi(str);  
				// cout<<"number of total pair production points:"<<num1<<endl;
				break;
			}		
			
		}
		
		// double x_1[num1];		
		// double y_1[num1]; 
		
		
		std::vector<double>  x_1;
		std::vector<double>  y_1;
		
		bool test =true;
		for(Int_t i = 0;i<num1;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp1,"%lf %lf",&e,&cs); 
			// x_1[i]=e;   // keep energy
			// y_1[i]=cs;  // keep cross section
			x_1.push_back(e*1e14);  
			y_1.push_back(cs);
			
			
			// printf("%.9e %.9e\n",x_1[i],y_1[i]);
		}
		fclose(fp1);
		// cout<<endl;
		
		
		
		
		
		
		FILE * fp2 = fopen(dir2,"r");		
		loop =0;
		
		while(1)
		{	
			loop++;
			// if loop = 1 we read the first header line
			fgets (str, 64, fp2);
			if(loop ==2)
			{
				// now loop = 2, we read the second header line, namely the number of points
				num2 = stoi(str);  
				// cout<<"number of total pair production points:"<<num2<<endl;
				break;
			}		
			
		}
		

		std::vector<double>  x_2;
		std::vector<double>  y_2;
		
		
		for(Int_t i = 0;i<num2;++i)
		{
			// read one line energy cross section
			ncols = fscanf(fp2,"%lf %lf",&e,&cs); 
			// x_2[i]=e; // keep energy
			// y_2[i]=cs; // keep cross section
			
			x_2.push_back(e);  
			y_2.push_back(cs);
			
		}
		fclose(fp2);
		
		std::vector<double> r;  // ratio (%): (EPICS2017-Livermore)/Livermore *100 ;
	
		// for(Int_t j=0;j<num1;++j) //EPICS2017  x_1
		// {
			// // printf(s"%d %.9e \n", j+1, x_1[j]);
		// }
		
		// for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		// {
			// // printf("%d %.9e \n", i+1, x_2[i]);
			// if(i ==4)
			// {
				// printf("%d %.9e \n", i+1, x_2[i]);
			// }
			// if(x_2[4]==x_1[6]) 
			// {
				// printf("yes");
			// }
			// printf("%d %.9e %.9e\n", i+1, x_2[4], x_1[6]);
		// }
		double ratioMax = 0;
		for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		{
			bool isFound = false;
			
			for(Int_t j=0;j<num1;++j) //EPICS2017  x_1
			{
				// if(j ==6 && i ==4) printf("%d %.9e %.9e \n", j+1, x_1[j], x_2[i]);
				if(IsEqual(x_2[i],x_1[j], eps, releps ))
				{	
					// x_4[num4] = x_2[i];
					// printf("%d %d %.9e %.9e \n", i+1, j+1, x_1[j], x_2[i]);
					
						
					double ratio = (y_1[j] - y_2[i])/y_2[i]*100; // cout<<x_1[j]<<"===="<<r[num4]<<endl;
					r.push_back(ratio);
					// printf("%d %.9e %.9e %.9e %.9e %.9e\n", i, x_1[j], x_2[i],y_1[j], y_2[i], ratio );
					// flag++;
					// num4++;
					//cout<<i<<"-----EPICS2017=="<<y_1[j]<<"-----Livermore==" << y_2[i]<<"*****Ratio=="<<r[i]<<endl;
					isFound = true;
					
					if(abs(ratio)>abs(ratioMax)) ratioMax = ratio;
					break;
					
				}
				
			}
			if(!isFound) 
			{
				printf("%d %.9e *********************Not found\n", i+1, x_2[i]);
			}
				
		
				
		}
		
		RatioInfo ratioInfo;
		ratioInfo.z = z;
		ratioInfo.ratioMax = ratioMax;
		ratioMaxVec.push_back(ratioInfo);
		
		// return;
		
		// for(Int_t i=0;i<num2;++i)  //EPDL2014  x_2
		// {
			// printf("%d %.9e %.9e\n", i+1, x_2[i], r[i]);
		// }
		
		
		TCanvas* mycanvas = new TCanvas(S,"Conversion of electrons and gammas",600, 10, 400, 400);
		
		mycanvas->SetGrid();
		//TPad* pad1 = new TPad("pad1","This is pad1",0.05,0.52,0.95,0.97);
		// TPad* pad1 = new TPad("pad1","This is pad1",0.0,0.4,1.0,1.0);
		// TPad* pad2 = new TPad("pad2","This is pad2",0.0,0.0,1.0,0.4);
		// pad1->Draw();
		// pad2->Draw();
		
		// pad2->cd();
		// TPad* pad21 = new TPad("pad21","First subpad of pad2",0.1,0.0,0.5,1.0);
		// TPad* pad22 = new TPad("pad22","Second subpad of pad2",0.5,0.0,0.9,1.0);
		// pad21->Draw();
		// pad22->Draw();
		
		
		gPad->SetGrid();
		gPad->SetLogx();
		// gPad->SetLogy();
		gPad->SetBottomMargin(0.15);
		gPad->SetLeftMargin(0.15);
		// gPad->SetLeftMargin(0.01);
		//gPad->SetLogy();
					
		// TGraph *graph1 = new TGraph(num1,x_1,y_1);
		// TGraph *graph2 = new TGraph(num2,x_2,y_2);
		TGraph *graph1 = new TGraph(x_1.size(),x_1.data(),y_1.data());
		TGraph *graph2 = new TGraph(x_2.size(),x_2.data(),y_2.data());
		
		auto mg = new TMultiGraph();
		
	   
		
		//set graph parameters of EPICS2014
		graph1->SetMarkerStyle(21);  // red point
		graph1->SetMarkerSize(1.4);
		graph1->SetMarkerColor(kRed);
		//graph1->SetLineWidth(2);
		graph1->SetLineColor(kRed);	
		mg->Add(graph1);
		mg->Draw("AP");
				
		//set graph parameters of livermore
		graph2->SetMarkerStyle(21);  //blue circle
		graph2->SetMarkerSize(0.8);
		graph2->SetMarkerColor(kBlue);
		graph2->SetLineColor(kBlue);
		
		mg->Add(graph2);
		
		// mg->SetTitle(title);		
		mg->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		mg->GetYaxis()->SetTitle("Form factor");
		
		// mg->GetXaxis()->SetTitleSize(0.06);
		// mg->GetYaxis()->SetTitleSize(0.06);
		
		// mg->GetXaxis()->SetLabelSize(0.05);
		// mg->GetYaxis()->SetLabelSize(0.05);
		
		mg->GetXaxis()->SetTitleOffset(1.5);
		mg->GetYaxis()->SetTitleOffset(1.5);
		
		
		
		mg->GetXaxis()->CenterTitle();
		mg->GetYaxis()->CenterTitle();
		
		TGaxis *axisX = new TGaxis(TMath::Power(10, gPad->GetUxmin()),gPad->GetUymax(),
		TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg->GetXaxis()->GetXmin(),
		mg->GetXaxis()->GetXmax(), 510,"GU-");
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisX->Draw("");
			
		
		TGaxis *axisY = new TGaxis(TMath::Power(10, gPad->GetUxmax()),gPad->GetUymin(),
			TMath::Power(10, gPad->GetUxmax()), gPad->GetUymax(),
		mg->GetYaxis()->GetXmin(),
		mg->GetYaxis()->GetXmax(), 510,"U+");
		
		// axis->SetLineColor(kRed);
		// axis->SetLabelColor(kRed);
		axisY->Draw();
		
		
		
		
		
		// graph2->SetMaximum(5e-25); 
		// graph2->SetMinimum(1e-35); 
		
		
		TLegend* leg = new TLegend(0.65,0.7,0.9,0.9);
		// leg->SetTextAlign(12);
		leg->SetFillColor(0);	
		leg->SetTextSize(0.04);
		
		
		TString Tnum1 = sInt(x_1.size());		
		TString Tnum2 = sInt(x_2.size());	
		
		TString name1 = "EPDL2017 - "+ Tnum1 + " points";
		TString name2 = "Livermore - "+ Tnum2 + " points";		
		
		leg->AddEntry(graph1,name1);
		leg->AddEntry(graph2,name2);
		//leg->DrawClone("Same");
		// leg->Draw();
		
		mycanvas->Print("plots/formfactor/2014vs2017-re-ff-"+ S +".png");
		// mycanvas->Close();
		
		// mycanvas->cd(2);
		// gPad->SetLogx();		
		// // gPad->SetTopMargin(0.12);
		// gPad->SetBottomMargin(0.15);
		// gPad->SetLeftMargin(0.12);
		// // gPad->SetBottomMargin(0.15);
		// // gPad->SetGrid();
		// // gStyle->SetTitleW(0.9);  //per cent of the pad width
		// // gStyle->SetTitleH(0.9);
		// // gStyle->SetTitleFontSize(0.9);
		
		// // // pad21->SetLeftMargin(0.10); //10%
		
		
		// char nameRatio[100] = "Relative difference of EPICS2017 compared to EPICS2014";	
		
		// TGraph *ratio = new TGraph(x_2.size(),x_2.data(),r.data());
		// auto mg1 = new TMultiGraph();
		// ratio->SetMarkerStyle(8);
		// ratio->SetMarkerSize(0.5);
		// ratio->SetMarkerColor(2);
		// ratio->SetLineColor(2);
		// mg1->Add(ratio);
		// mg1->Draw("AP");
		
		// mg1->SetTitle(nameRatio);
		// mg1->Draw();
		// mg1->GetXaxis()->SetTitle("Momentum transfer (cm^{-1})");
		// mg1->GetYaxis()->SetTitle("Relative Difference (%)");
		
		// mg1->GetXaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleSize(0.06);
		// mg1->GetYaxis()->SetTitleOffset(0.9);
		
		// mg1->GetXaxis()->SetLabelSize(0.05);
		// mg1->GetYaxis()->SetLabelSize(0.05);
			
		// mg1->GetXaxis()->CenterTitle();
		// mg1->GetYaxis()->CenterTitle();
		
	
		
		// // TLatex latex;
		// // latex.SetTextSize(0.05);
		// // latex.SetTextAlign(22);
		// // latex.DrawLatexNDC(0.7,0.8,"RD = #frac{EPICS2017-EPICS2014}{EPICS2014} x 100");
		
		
		// // TString Tflag = sInt(flag);	
		// // Tflag += " points in comparison";
		// // latex.SetTextColor(2);
		// // latex.DrawLatexNDC(0.7,0.7,Tflag);
		
		
		
		
		// // // TLegend* leg212 =  new TLegend(0.12,0.7,0.3,0.88);
		// // // TString Tnum4 = sInt(num2);
		// // // TString name4 = Tnum4 + " points in comparison";		
		// // // leg212->AddEntry(ratio,name4);
		// // // leg212->SetTextAlign(22);
		// // // leg212->SetFillStyle(0);
		// // // leg212->Draw();
		// // // leg212->SetTextSize(0.05);
		
		
		
		
		// // //***********(begin)for the zoomin of the ratio 
		
		
		
		
		
		
}

void plot_formfactor(){
	
	gROOT->Reset();
	// create the 2 directories if they do not exist if
	gSystem->Exec("mkdir -p plots/formfactor");
	
	
		
    
	for (Int_t z = 1;z<=100;++z)// number of element Z, from 1 to 100
	{
		
		if((z != 1) && (z != 13) && (z != 82)) continue;
		char path1Format[128] = "epics2017/formFactor/re-ff-%d.dat"; //prefix of the name of original data file
		char path1[128];
		
		char path2Format[128] = "epics2014/formFactor/re-ff-%d.dat"; //prefix of the name of original data file
		char path2[128];
		
		sprintf(path1,path1Format, z);
		sprintf(path2,path2Format, z);
		
		// plotSingle(z,1,path1);
		// plotSingle(z,2,path2);			
		// plotComparison(z, path1, path2);
		plotComparison_for_publication(z, path1, path2);
		
			
	}
	
	//only working when all the elements are compared
	FILE* out = fopen("MaximalDifferenceOfFormFactorBetween2014And2017.txt", "w");
	std::vector<RatioInfo>::iterator iter;
	double ratioMax;
	int Z = 0;
	for(iter = ratioMaxVec.begin(); iter != ratioMaxVec.end(); iter++)
	{
		fprintf(out,"%d %.9e%%\n", 
					(*iter).z,  (*iter).ratioMax);
		
		if(abs((*iter).ratioMax) > abs(ratioMax))
		{
			ratioMax = (*iter).ratioMax;
			Z = (*iter).z;			
			
		}
	}
	fclose(out);
	
	cout<<"results="<<results<<", results2="<<results2<<", results3="<<results3<<endl;
	cout<<"results1="<<results1<<endl;
	cout<<"for the following elements, all points in EPICS2014 are found in EPICS2017"
	<<endl;
	for(std::vector<int>::iterator it = resultsV.begin(); it!=resultsV.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	cout<<"results4="<<results4<<" Only two elements do not have errors of overlapping energy pairs,\
	namely element 1 and 2"<<endl;
	
	cout<<"results5="<<results5<<endl;
	cout<<"for the following elements, it has exceptions due to the precision"<<endl;
	
	for(std::vector<int>::iterator it = results5V.begin(); it!=results5V.end(); it++)
	{
		cout<<*it<<endl;
	}
	
	
}